// Lisp2D - Universal method = , <>
//            for many Types ( not nil , false , true )
// ©2017-23 by Alex Glebe
# include "eqnoteq.h"
# include "boolean.h"
# include "sharedc.h"
# include "shared/inline.h"
# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"
// me eq : me  
// me eq me : me
// me eq notme : false
// me noteq : me
// me noteq notme : me
// me noteq me : false
TaskForThread bimUniversalEqNotEq ( FuncComparisonNoStclP const f , StackClusterPrivate * const  stclpp  ) {
  ParaLispObject  * const mep  =  StackClusterPrivate_ThisTop ( stclpp ) ;
  ParaLispObject  * j ;
  ParaLispObject  * res = & plonil .  plo  ;
  if  ( StackClusterPrivate_ClearflagCont  ( stclpp ) ) {
    StackClusterPrivate_Pop ( stclpp ,  & j ) ;
    goto  Next  ; 
  }
  j =  StackClusterPrivate_ArgTop  (  stclpp )  ;
Next  :
  for ( unsigned  int tasks = maxListItemProcessing  ; ( tasks  > 0  ) and CConsp (  j ) ;
    j = ClassCons_Rest  ( & ParaLispObjectToPLOCons  ( j )  ->  cc ) , -- tasks  ) {
    BoolType const fres  = ( * f ) ( mep  , ClassCons_First ( & ParaLispObjectToPLOCons ( j ) ->  cc ) )  ;
    if  ( fres  ==  Lisp2DBoolUndef )
      goto  Quit  ;
    if  ( fres  ==  Lisp2DBoolFalse ) {
      res =  &  plofalse.plo  ;
      goto  Quit  ; 
    } 
  }
  if  ( CConsp (  j ) ) {
    StackClusterPrivate_setTaskForManager ( stclpp , TaskPause ) ;
    StackClusterPrivate_SetflagCont  ( stclpp , 1U ) ; 
    StackClusterPrivate_Push ( stclpp , j ) ;
    goto  Exit  ; 
  }
  res = mep ;
Quit  :
  StackClusterPrivate_SetResult ( stclpp , res ) ;
Exit  :
  return  TaskForThread_Analyse ; 
}
