// FractionLoadChastDelitFromString
# include <iso646.h> // and not
# include <ctype.h> // isdigit
# include "cast.h"

# define  CharToDigit Lisp2DCharToDigit8643
static  unsigned  int CharToDigit ( wchar_t ssj , unsigned  int f10 ) ;

# include "fraction/public.h"

# define  s_fract_flagpoint Lisp2D_s_fract_flagpoint
# define  t_fract_flagpoint Lisp2D_t_fract_flagpoint
typedef struct  s_fract_flagpoint t_fract_flagpoint ;

struct  s_fract_flagpoint {
  size_t  * const jp  ;
  size_t  const i ;
  String  ( WideChar  ) const * const wsp ;
  bool  * const lerr  ;
  ULongPub  * ch  ;
  ULongPub  * de  ;
  bool  * const flagImp ;
  FractionPub * const rf0 ;
  unsigned  int f10 ;
  bool  flagExp ;
  bool  flagdelit ;
  bool  flagreturn  ;
} ;

# define  fract_flagpoint Lisp2D_fract_flagpoint
static  void  fract_flagpoint ( t_fract_flagpoint * ) ;

# include "stack/public.h"

// !! very slow: 123e12345
// string may partially compiled
// in start rf=0/1
bool  FractionLoadChastDelitFromString  ( t_FractionLoadChastDelitFromString  const * const arg ) {
  t_fract_flagpoint ffp = {
    . jp  = arg -> jp  ,
    . i = arg -> i ,
    . wsp = arg -> wsp ,
    . lerr  = arg -> lerr  ,
    . ch = 0UL ,
    . de = 0UL ,
    . flagImp = arg -> flagImp ,
    . rf0 = arg -> rf0 ,
    . f10 = 10U ,
    . flagExp = false ,
    . flagdelit = false ,
    . flagreturn  = false ,
  } ;
  // in start rf=0/1
  // +-abc.defE+-mn
  // abc.defE+-mn | 0xabc.defE+-mn
  if  ( Vector_EltCopy  ( StringWideChar  ) ( arg -> wsp , * ( arg -> jp ) )  ==  '0'  ) {
    (*(arg -> lerr)) = false;
    ++  (*(arg -> jp));
    if(((*(arg -> jp))  + 1) < (arg -> i))
      if((Vector_EltCopy ( StringWideChar )(arg -> wsp,*(arg -> jp))  ==  'x') or
        (Vector_EltCopy ( StringWideChar )(arg -> wsp,*(arg -> jp))  ==  'X')){
        ffp.f10 = 16U;
        ++  (*(arg -> jp));
      }
  }
  ThreadStackPointerType const oldstack_ch = Lisp2DThreadSP ( ) ;
  ffp . ch = StackNew_ULong ( ) ;
  ULong_ConstrCopy ( ffp . ch , FractionCNump  ( arg -> rf0 ) ) ;
  ffp . de = StackNew_ULong ( ) ;
  ULong_ConstrCopy ( ffp . de , FractionCDenomp  ( arg -> rf0 ) ) ;
  // abc.defE+-mn
  fract_flagpoint ( & ffp ) ;
  if ( ffp . flagreturn ) {
    Lisp2D_StackFree  ( oldstack_ch ) ;
    return  ffp . flagdelit  ;
  }
  if( * (arg -> lerr )){
    Lisp2D_StackFree  ( oldstack_ch ) ;
    return  ffp . flagdelit;
  }
  if((not ffp.flagdelit)  and ffp . flagExp){
    // E +-mn
    int  flagsignP = 1 ;
    if(Vector_EltCopy ( StringWideChar )(arg -> wsp,(*(arg -> jp)))  ==  '-'){
      flagsignP = -1;
      ++  (*(arg -> jp));
    } else
      if(Vector_EltCopy ( StringWideChar )(arg -> wsp,(*(arg -> jp)))  ==  '+')
        ++  (*(arg -> jp));
    // mn | 0x123
    unsigned  int  f10p = 10U ;
    if(Vector_EltCopy ( StringWideChar )(arg -> wsp,(*(arg -> jp)))  ==  '0'){
      ++  (*(arg -> jp));
      if((*(arg -> jp))  < (arg -> i  - 1))
        if((Vector_EltCopy ( StringWideChar )(arg -> wsp,(*(arg -> jp))) ==  'x') or
          (Vector_EltCopy ( StringWideChar )(arg -> wsp,(*(arg -> jp))) ==  'X')){
          f10p  = 16U;
          ++  (*(arg -> jp));
        }
    }
    // mn
    //  0/1
    ThreadStackPointerType const oldstack_rfpp = Lisp2DThreadSP ( ) ;
    FractionPub * const rfp = NewStackFraction  ( ) ;
    FractionConstrZero  (rfp);

    for(;(*(arg -> jp))  < (arg -> i  - 1);++ (*(arg -> jp))){
      wchar_t volatile const * const charssjp=StringEltCAddr(WideChar)(arg -> wsp,*(arg -> jp));
      if((*charssjp)  ==  '.'){
        (*(arg -> lerr)) = true;
        break;
      }
        if(((f10p ==  10U)  and isdigit(*charssjp) ) or
          ((f10p  ==  16U) and ( isdigit(*charssjp) or
            (((*charssjp) >=  'a') and ((*charssjp) <=  'f'))))){
          FractionMulUInt  (  rfp , f10p  ) ;
          FractionAddUInt ( rfp , CharToDigit(*charssjp,f10p) ) ;
        } else {
          if((*charssjp)  ==  '/'){
            ffp.flagdelit = true;
            ++  (*(arg -> jp));
          } else {
            if((*charssjp)  ==  'i' ) {
              (*(arg -> flagImp))  = true;
              ++  (*(arg -> jp));
            }
          }
          break;
        }

    } // for *jp
    if( * (arg -> lerr )){
      Lisp2D_StackFree  ( oldstack_ch ) ;
      return  ffp.flagdelit;
    }
    if(not  (FractionEqUInt(rfp,0U))) {
      ThreadStackPointerType const oldstack_f10xp = Lisp2DThreadSP ( ) ;
      FractionPub * const f10x = NewStackFraction ( ) ;
      FractionConstrUInt  ( f10x ,ffp.f10);
      FractionPower(f10x,rfp);
      // ! to Clear ?
      FractionClearMoveSignULongULong  ( arg -> rf0 , false , ffp . ch , ffp . de ) ;
      if(flagsignP  ==  1)
        FractionMultMoveFraction ( arg -> rf0 , f10x ) ;
      else
        FractionDivFractionMove  ( arg -> rf0 , f10x ) ;
      Lisp2D_StackFree  ( oldstack_f10xp ) ;
    } else
      // ! to Clear ?
      FractionClearMoveSignULongULong  ( arg -> rf0 , false , ffp . ch , ffp . de ) ;
    Lisp2D_StackFree  ( oldstack_rfpp ) ;
  } else // if flagExp
    // ! to Clear ?
    FractionClearMoveSignULongULong  ( arg -> rf0 , false , ffp . ch , ffp . de ) ;
  Lisp2D_StackFree  ( oldstack_ch ) ;
  return  ffp.flagdelit ;
}

static  void  fract_flagpoint ( t_fract_flagpoint * const arg ) {
  bool  flagpoint = false ;
  for(;(*(arg->jp))  < ((arg -> i) - 1);++  (*(arg->jp))){
    wchar_t  charssj = int_cast_wchar( tolower(Vector_EltCopy ( StringWideChar )((arg->wsp),(*(arg->jp)))) );
    if(charssj  ==  '.'){
      (*(arg->lerr)) = false;
      flagpoint = true;
      ++  (*(arg->jp));
      break;
    }
    if ( ( ( (arg->f10) not_eq  10U ) or ( not isdigit ( charssj ) ) ) and
        ( not ( ( (arg->f10) ==  16U ) and ( isdigit ( charssj ) or
          ( ( charssj >=  'a' ) and ( charssj <=  'f' ) ) ) ) ) ) {
      if(charssj  ==  '/'){
        arg->flagdelit = true;
        ++  (*(arg->jp));
        break;
      }
      if(((arg->f10) ==  10)  and (charssj ==  'e')){
        arg->flagExp = true;
        ++  (*(arg->jp));
        break;
      }
      if(charssj  ==  'i'){
        (*(arg->flagImp))  = true;
        ++  (*(arg->jp));
        break;
      }
      // ! to Clear ?
      FractionClearMoveSignULongULong  ( arg->rf0 , false , arg->ch , arg->de ) ;
      arg -> flagreturn = true  ;
      return ;
    }
    (*(arg->lerr)) = false;
    ULongMultiplyUInt ( (arg->ch) , (arg->f10) ) ;
    ULongAddUInt ( (arg->ch) , CharToDigit ( charssj , (arg->f10) ) ) ;
  }  // for
  if ( * (arg->lerr) ) {
    arg -> flagreturn = true  ;
    return  ;
  }
  if((not arg->flagdelit)  and flagpoint) {
    // . defE+-mn
    for(;(*(arg->jp))  < ((arg->i)  - 1);++ (*(arg->jp))){
      wchar_t  charssj = int_cast_wchar(
        tolower(Vector_EltCopy ( StringWideChar )(arg->wsp,(*(arg->jp)))));
      if(charssj  ==  '.'){
        (*(arg->lerr)) = true;
        break;
      }
      if ( ( ( (arg->f10)  not_eq  10U ) or ( not ( isdigit ( charssj ) ) ) ) and
          ( not ( ( (arg->f10) ==  16U ) and ( isdigit ( charssj ) or
          ( ( charssj >=  'a' ) and ( charssj <=  'f' ) ) ) ) ) ) {
        if(charssj  ==  '/'){
          arg->flagdelit = true;
          ++  (*(arg->jp));
          break;
        }
        if((arg->f10 ==  10)  and (charssj ==  'e')){
          arg->flagExp = true;
          ++  (*(arg->jp));
          break;
        }
        if(charssj  ==  'i'){
          (*(arg->flagImp))  = true;
          ++  (*(arg->jp));
          break;
        }
        // ! to Clear ?
        FractionClearMoveSignULongULong  ( arg->rf0 , false , arg->ch , arg->de ) ;
        arg -> flagreturn = true  ;
        return  ;
      }
      (*(arg->lerr)) = false;
      ULongMultiplyUInt ( arg->ch , arg->f10 ) ;
      ULongAddUInt (  arg->ch , CharToDigit ( charssj , arg->f10 ) ) ;
      ULongMultiplyUInt ( arg->de , arg->f10 ) ;
    }  // for
  } // if
} // flagpoint

static  unsigned  int CharToDigit ( wchar_t const ssj , unsigned  int const f10 ) {
  if((f10 ==  16U) and (not  isdigit(ssj)))
    return int_cast_uint (ssj  -
      ( islower(ssj) ?
        L'a' :
        L'A') ) + 10U;
  return  int_cast_uint (ssj  - L'0');
}

# include "castb.h"
# include "widestring/inline.h"
