// Lisp2D - Stack of AddrForReturn for StackCluster
// ©2018-23 by Alex Glebe

# include "stack-define.h"
# include "eval-addr/public.h"
# include "addrforreturn/public.h"
# include "stack-addrforreturn.h"
# include "sharedc.h"

LISP2D_PROTO_STACK_FREE ( StackAddrForReturn )
LISP2DSTACKPOP  ( StackAddrForReturn  , AddrForReturn , )
LISP2DSTACKPUSHBYVALUE  ( StackAddrForReturn  , AddrForReturn , )
LISP2DSTACKDESTRUCTOR ( StackAddrForReturn , AddrForReturn )
LISP2D_STACK_FREE ( StackAddrForReturn , AddrForReturn )
LISP2DSTACKCLEAR ( StackAddrForReturn , AddrForReturn )
LISP2DSTACKBACKCOPY ( StackAddrForReturn , AddrForReturn )

# include "shared/inline.h"
