// Lisp2D - Stack of wide characters
// ©2019-23 by Alex Glebe

# include "stack-define.h"
# include "stack-widechar.h"
# include "sharedc.h"
# include "shared/inline.h"

LISP2DSTACKRESIZE  ( WideChar , wchar_t , volatile )
LISP2DSTACKRESIZE1 ( WideChar , wchar_t , volatile )
LISP2DSTACKELTCOPY  ( WideChar , wchar_t )
LISP2DSTACKPUSHFRONTVALUE  ( WideChar , wchar_t , volatile )
LISP2DSTACKPUSHBYVALUE  ( WideChar , wchar_t , volatile )
LISP2DSTACKINSERTFRONT  ( WideChar , wchar_t , volatile )
LISP2DSTACKSET  ( WideChar , wchar_t , volatile )
LISP2DSTACKDESTRUCTOR ( WideChar , wchar_t )
LISP2D_STACK_FREE ( WideChar , wchar_t )
LISP2DSTACKCLEAR  ( WideChar , wchar_t )
LISP2DSTACKSWAP  ( WideChar , wchar_t volatile )
LISP2DSTACKPOP ( WideChar , wchar_t , volatile )
LISP2DSTACKCONSTRUCTORCOPY  ( WideChar , wchar_t  )
LISP2DSTACKCONSTRUCTORMOVE  ( WideChar , wchar_t  )
LISP2DSTACKBACKCOPY ( WideChar , wchar_t  )
LISP2DSTACKREMOVEFRONT  ( WideChar , wchar_t , volatile )
LISP2DSTACKAT  ( WideChar , wchar_t volatile )
LISP2DSTACKATCOPY  ( WideChar , wchar_t  )
LISP2DSTACKFRONTCOPY  ( WideChar , wchar_t  )
LISP2DSTACKCEND  ( WideChar , wchar_t volatile )
LISP2DSTACKCBACK  ( WideChar , wchar_t volatile )
LISP2DSTACKBACK  ( WideChar , wchar_t volatile )
LISP2DSTACKCREND  ( WideChar , wchar_t volatile )
LISP2DSTACKCRBEGIN  ( WideChar , wchar_t volatile )
LISP2DSTACKEND  ( WideChar , wchar_t volatile )
LISP2DSTACKISEQ ( WideChar , wchar_t  )
LISP2DSTACKCAT  ( WideChar , wchar_t volatile )
