// Threads for all processors
// Thread for console task: getch
// ©2007-23 by Alex Glebe

# include "thread.h"
# include "sharedc.h"
# include "shared/inline.h"

void  RunningPthArgsInit  ( RunningPthArgs * const me ) {
# ifdef LISP2D_DEBUG
  me -> debugStartEval = false ;
# endif
  pthread_mutex_init  ( & me -> ready_mutex , 0 ) ;
  me -> promise_state = false ;
  me -> promise_exc = false  ;
  pthread_cond_init ( & me -> ready_cond  , 0 ) ;
  pthread_cond_init ( & me -> condrunning2  , 0 ) ;
  me -> taskp = 0 ;
  me -> flagWaitSignal  = true   ;
# ifdef  LISP2D_CONSTRSTAT
  ++  RunningPthArgsconstrstat  ;
# endif
}

void  RunningPthArgsDestr ( RunningPthArgs * const me ) {
  pthread_cond_destroy  ( & me  ->  condrunning2  ) ;
  pthread_cond_destroy  ( & me  ->  ready_cond  ) ;
  pthread_mutex_destroy ( & me  ->  ready_mutex ) ;
}

# ifdef  LISP2D_CONSTRSTAT

volatile  _Atomic ( size_t  ) RunningPthArgsconstrstat  = 0 ;  

size_t  RunningPthArgsconstrstatValue ( void  ) {
  return  RunningPthArgsconstrstat  ;
}

# endif  

RunningPthArgs  * runpthargs = 0 ;
