// UnQuoteSplicing ,@
// ©2011-23 by Alex Glebe
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include "unquotesplicing/private.h"

_Atomic ( size_t ) PLOUnQuoteSplicing_constrstat = 0 ;

# endif // LISP2D_CONSTRSTAT

# include "unquotesplicing/public.h"

# ifdef  LISP2D_CONSTRSTAT

void  UnQuoteSplicing_constrstat_Inc  ( void  ) {
  ++  PLOUnQuoteSplicing_constrstat  ;
}

size_t  UnQuoteSplicing_constrstat_Value  ( void  ) {
  return  PLOUnQuoteSplicing_constrstat  ;
}

# endif // LISP2D_CONSTRSTAT

# include "symbolc.h"

# define  PLOUnQuoteSplicing_staticTypeOf Lisp2D_PLOUnQuoteSplicing_staticTypeOf
ParaLispObject  * PLOUnQuoteSplicing_staticTypeOf ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  & plosUnquoteSplicing . plo  ;
}

# include "sharedc.h"
# include "shared/inline.h"
# include "unquotesplicing/struct.h"
# include "plostream/struct.h"

# define  PLOUnQuoteSplicing_Cout Lisp2D_PLOUnQuoteSplicing_Cout
static  void  PLOUnQuoteSplicing_Cout  ( PLOUnQuoteSplicing * const me ,
  FuncCoutToInterpretHuman  funccout , PLOStream  const * const  sp , bool  flag2p  , Vector ( StackPLOP ) * const lookingp  ) {
  bool  flagp  = flag2p  ;
  if  ( Printed3Points  ( & me -> plo , sp , & flagp ,  lookingp ) )  
    return  ;
  StreamPushWCharArray  ( & sp -> str , ( PArray_wchar_c )  { ( wchar_t const ( * ) [ ] ) (  L",@" ) } ) ;
  Vector_PushByValue ( StackPLOP ) (  lookingp , & me -> plo ) ;
  funccout ( me -> item ,  sp , &  flagp  ,  lookingp ) ;
  VectorPop(StackPLOP) (  lookingp ) ;
}

bool  PLOUnQuoteSplicing_staticisBADCopyPrivate ( ParaLispObject const * const  me , ParaLispObject  * * const resultp  ) {
  { PLOUnQuoteSplicing * const  res  = aligned_alloc ( _Alignof ( PLOUnQuoteSplicing ) , sizeof ( PLOUnQuoteSplicing ) ) ;
    if  ( res ) {
      PLOUnQuoteSplicing_Init(res);
      PLOUnQuoteSplicing_SetItem ( res ,
        ParaLispObjectToPLOUnQuoteSplicingConst(me) -> item ) ;
      ParaLispObject_virtualPushAsNew (&res ->  plo ) ;
      ( * resultp )  = &res->plo ;
      return  false ;
    }
  }
  return  true  ;
}

void  PLOUnQuoteSplicing_staticGCDeclareContent ( ParaLispObject * const me ) {
  ParaLispObject_virtualDeclareForGC ( 
    ParaLispObjectToPLOUnQuoteSplicing(me) -> item ) ;
}

# include "nilc.h"

void  PLOUnQuoteSplicing_Init( PLOUnQuoteSplicing * const me ) {
  me -> item  = &  plonil.plo ;
  { VirtualTypePointer  vtp = { . addr = { . p = me } , . type = TypeGlobalListMemberPLOUnquoteSplicing } ;
    ParaLispObject_InitVTP(&me->plo ,vtp );
  }
# ifdef  LISP2D_CONSTRSTAT
  UnQuoteSplicing_constrstat_Inc ( ) ;
# endif
}

void  PLOUnQuoteSplicing_staticCoutToInterpret ( ParaLispObject const * const me , PLOStream  const * const s ,
  bool const flag2pprinted  , Vector  ( StackPLOP ) * const h ) {
  PLOUnQuoteSplicing_Cout  ( ParaLispObjectToPLOUnQuoteSplicing  ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToInterpret , s , flag2pprinted , h ) ;
}

void  PLOUnQuoteSplicing_staticCoutToHuman ( ParaLispObject const * const me ,
  PLOStream  const * const s , bool const flag2pprinted  , Vector  ( StackPLOP )  * const h ) {
  PLOUnQuoteSplicing_Cout  ( ParaLispObjectToPLOUnQuoteSplicing  ( ( ParaLispObject * ) me  ) ,
    ParaLispObject_CoutToHuman , s , flag2pprinted , h ) ;
}

# include "cons/inline.h"
# include "stcl/public.h"
# include "stcl/inline.h"

// 'unquote-splicing newobject (2 + 2) -> ,@4
TaskForThread Lisp2DbimUnquoteSplicingUnquoteSplicing2  ( StackClusterPrivate  * const stclpp  ) {
  PLOUnQuoteSplicing  * const mep  =ParaLispObjectToPLOUnQuoteSplicing ( StackClusterPrivate_ThisTop(stclpp))  ;
  PLOUnQuoteSplicing_SetItem ( mep , CCAR ( StackClusterPrivate_ArgTop(stclpp)) ) ;
  StackClusterPrivate_SetResult (stclpp,& mep -> plo  ) ;
  return  TaskForThread_Analyse ;
}

// unquote-splicing setf unquote-splicing
TaskForThread Lisp2DbimUnquoteSplicingsetf2 ( StackClusterPrivate * const stclpp ) {
  PLOUnQuoteSplicing  * const mep  =ParaLispObjectToPLOUnQuoteSplicing ( StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp =  CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotType ( unQuoteSplicing ) (  stclpp  ,  argp ) ) {
    PLOUnQuoteSplicing_Set (  mep , ParaLispObjectToPLOUnQuoteSplicing ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep -> plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

// unquote-splicing swap unquote-splicing
TaskForThread Lisp2DbimUnquoteSplicingswap2 ( StackClusterPrivate * const stclpp ) {
  PLOUnQuoteSplicing  * const mep = ParaLispObjectToPLOUnQuoteSplicing (
    StackClusterPrivate_ThisTop(stclpp))  ;
  ParaLispObject  * const argp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  if  ( not  IsNotType ( unQuoteSplicing ) (  stclpp  ,  argp ) ) {
    if  ( IsConst (   stclpp ,  argp ) )
// ! to exception
      return  TaskForThread_Analyse ;
    PLOUnQuoteSplicing_Swap  (  mep , ParaLispObjectToPLOUnQuoteSplicing ( argp ) ) ;
    StackClusterPrivate_SetResult (stclpp ,& mep->plo  ) ;
  }
  return  TaskForThread_Analyse ;
}

# include "boolean.h"

TaskForThread Lisp2DbimnilUnquoteSplicingP2 ( StackClusterPrivate * const stclpp ) {
  ParaLispObject  * const xp = CCAR ( StackClusterPrivate_ArgTop(stclpp))  ;
  StackClusterPrivate_SetResult (stclpp ,( UnQuoteSplicingP (  xp )  ?
    xp :
    &  plofalse.plo )) ;
  return  TaskForThread_Analyse ;
}

IsNotTypeTemplBody  ( unQuoteSplicing , TypeGlobalListMemberPLOUnquoteSplicing )

ParaLispObject  * PLOUnQuoteSplicing_staticClassDef  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return  ploclassdefUnquoteSplicing  ;
}

ParaLispObject  * PLOUnQuoteSplicing_staticClassParents  ( ParaLispObject const * _ __attribute__ ((unused)) ) {
  return   ploclassparentsUnquoteSplicing  ;
}

void  PLOUnQuoteSplicing_Destr ( PLOUnQuoteSplicing * const me ) {
  ParaLispObject_staticDestr(&me->plo); 
}

void PLOUnQuoteSplicing_staticDestr  ( ParaLispObject * const me ) {
  PLOUnQuoteSplicing_Destr  ( ParaLispObjectToPLOUnQuoteSplicing ( me  )  ) ;
}

void  PLOUnQuoteSplicing_Swap  ( PLOUnQuoteSplicing * const me , PLOUnQuoteSplicing * const xp  ) {
  if ( me not_eq xp ) {
    ParaLispObject  * const myitem  = me -> item  ;
    me -> item = xp -> item ;
    xp -> item = myitem ;
  }
}
