// (C)2019-23 Lisp2D Atomic Mutex
# ifndef  LISP2D_ATOMIC_MUTEX
# define  LISP2D_ATOMIC_MUTEX

# include <stdint.h>
# include <iso646.h>
# include <stdbool.h>
# include "excc.h"
# include "atomic_mutexp.h"
# include "define.h"

void  Lisp2D_atomic_mutex_init  ( Lisp2D_atomic_mutex * ) ;
void  Lisp2D_atomic_mutex_lock  ( Lisp2D_atomic_mutex * ) ;
bool  Lisp2D_atomic_mutex_trylockOK  ( Lisp2D_atomic_mutex * ) ;
void  Lisp2D_atomic_mutex_unlock  ( Lisp2D_atomic_mutex * ) ;
# ifdef LISP2D_DEBUG  
void  Lisp2D_atomic_mutex_destruct  ( Lisp2D_atomic_mutex * ) ;
# endif

# ifdef  LISP2D_BIMSTAT
# define  atomic_mutex_StatFast Lisp2Datomic_mutex_StatFast
size_t  atomic_mutex_StatFast  ( Lisp2D_atomic_mutex const * me ) ;
# define  atomic_mutex_StatWait Lisp2Datomic_mutex_StatWait
size_t  atomic_mutex_StatWait  ( Lisp2D_atomic_mutex const * me ) ;
# endif  

# endif
