// (C)2023 Lisp2D struct
# include <stddef.h>
# include <stdatomic.h>
# include "define.h"

# ifdef LISP2D_DEBUG  
# include "object-state.h"
# endif

struct Lisp2D_satomic_mutex ;
typedef struct Lisp2D_satomic_mutex Lisp2D_atomic_mutex ;

struct Lisp2D_satomic_mutex {
  atomic_flag atomflag  ;
# ifdef  LISP2D_BIMSTAT
  size_t  statfast  ;
  size_t  statwait  ;
# endif
# ifdef LISP2D_DEBUG  
  Lisp2DObjectState s ; 
# endif  
} ;
