// Lisp2D - ByteDeque #[] bytevector_length
// ©2014-23 by Alex Glebe
# ifndef  LISP2D_BYTEDEQUE_VECTORLENGTH_H
# define  LISP2D_BYTEDEQUE_VECTORLENGTH_H

# include <stddef.h> // size_t
# include "define.h"

# define  bytevector_length_value Lisp2D_bytevector_length_value
size_t  bytevector_length_value ( void  ) ;

# define  bytevector_length_inc Lisp2D_bytevector_length_inc
void  bytevector_length_inc ( void ) ;

# define  bytevector_length_dec Lisp2D_bytevector_length_dec
void  bytevector_length_dec ( void ) ;

# define  bytevector_length_add Lisp2D_bytevector_length_add
void  bytevector_length_add ( size_t ) ;

# define  bytevector_length_sub Lisp2D_bytevector_length_sub
void  bytevector_length_sub ( size_t ) ;

# define  bytevector_length_clear Lisp2D_bytevector_length_clear
void  bytevector_length_clear ( void ) ;

# ifdef  LISP2D_CONSTRSTAT

# define  PLOByteDeque_constrstat_inc Lisp2D_PLOByteDeque_constrstat_inc
void  PLOByteDeque_constrstat_inc ( void ) ;

# define  PLOByteDeque_constrstat_value Lisp2D_PLOByteDeque_constrstat_value
size_t  PLOByteDeque_constrstat_value ( void ) ;

# endif // LISP2D_CONSTRSTAT

# endif // LISP2D_BYTEDEQUE_VECTORLENGTH_H
