// Comma ,
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_COMMA_PUBLIC_H
# define  LISP2D_COMMA_PUBLIC_H

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

# define  PLOComma_constrstat_Inc  Lisp2D_PLOComma_constrstat_Inc
void  PLOComma_constrstat_Inc  ( void  ) ;
# define  PLOComma_constrstat_Value  Lisp2D_PLOComma_constrstat_Value
size_t  PLOComma_constrstat_Value  ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "comma/type.h"

# define  PLOComma_Init Lisp2D_PLOComma_Init
void  PLOComma_Init( PLOComma * ) ;

# define  PLOComma_Destr  Lisp2D_PLOComma_Destr
void  PLOComma_Destr ( PLOComma * ) ;

# include "plo/struct.h"

# define  PLOComma_staticTypeOf Lisp2D_PLOComma_staticTypeOf
ParaLispObject  * PLOComma_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOComma_staticClassDef Lisp2D_PLOComma_staticClassDef
ParaLispObject  * PLOComma_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOComma_staticClassParents Lisp2D_PLOComma_staticClassParents
ParaLispObject  * PLOComma_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOComma_staticGCDeclareContent Lisp2D_PLOComma_staticGCDeclareContent
void  PLOComma_staticGCDeclareContent ( ParaLispObject *  ) ;  

# define  PLOComma_staticisBADCopyPrivate Lisp2D_PLOComma_staticisBADCopyPrivate
bool  PLOComma_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOComma_staticCoutToHuman  Lisp2D_PLOComma_staticCoutToHuman
void  PLOComma_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;

# define  PLOComma_staticCoutToInterpret  Lisp2D_PLOComma_staticCoutToInterpret
void  PLOComma_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector ( StackPLOP )  *  h ) ;

# include "stcl/classc.h"
  
# define  IsNotComma  Lisp2D_IsNotComma
bool  IsNotComma  ( StackClusterPrivate *  , ParaLispObject  * ) ;

FuncBining  Lisp2Dbimcommacomma2  ;
  FuncBining  Lisp2Dbimnilcommap2 ;
  FuncBining  Lisp2Dbimcommasetf2 ;
  FuncBining  Lisp2Dbimcommaswap2 ;

# include "comma/type.h"

# define  ParaLispObjectToPLOComma  Lisp2DParaLispObjectToPLOComma
inline  PLOComma * ParaLispObjectToPLOComma ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOCommaConst Lisp2DParaLispObjectToPLOCommaConst
inline  PLOComma const * ParaLispObjectToPLOCommaConst ( ParaLispObject const * ) ;
# define  PLOComma_staticDestr  Lisp2D_PLOComma_staticDestr
void PLOComma_staticDestr  ( ParaLispObject * ) ;
# define  PLOComma_Swap Lisp2D_PLOComma_Swap
void  PLOComma_Swap  ( PLOComma * , PLOComma * ) ;
# define  PLOComma_Set  Lisp2D_PLOComma_Set
inline  void  PLOComma_Set ( PLOComma * , PLOComma  const * ) ;
# define  PLOComma_PItem  Lisp2D_PLOComma_PItem
inline  ParaLispObject  * * PLOComma_PItem ( PLOComma * ) ;
# define  PLOComma_SetItem  Lisp2D_PLOComma_SetItem
inline  void  PLOComma_SetItem ( PLOComma * , ParaLispObject  * ) ;
# define  PLOComma_Item Lisp2D_PLOComma_Item
inline  ParaLispObject  * PLOComma_Item  ( PLOComma const * ) ;
# define  CommaP  Lisp2D_CommaP
inline  bool  CommaP ( ParaLispObject const * ) ;

inline  PLOComma * ParaLispObjectToPLOComma ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr . p ;
}

inline  PLOComma const * ParaLispObjectToPLOCommaConst ( ParaLispObject const * const p ) {
  return p  ->  vaddr . addr . p ;
}

# include "comma/public.h"
# include "comma/struct.h"

inline  void  PLOComma_Set ( PLOComma * const me , PLOComma  const * const xp ) {
  me -> item = xp -> item ;
}

inline  ParaLispObject  * * PLOComma_PItem ( PLOComma * const me ) {
  return  & me -> item ;
}

inline  void  PLOComma_SetItem ( PLOComma * const me , ParaLispObject  * const xp ) {
  me -> item = xp ;
}

inline  ParaLispObject  * PLOComma_Item  ( PLOComma const * const me ) {
  return  me -> item ;
}

inline  bool  CommaP ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOComma  ;
}

# include "stcl/inline.h"

# endif // LISP2D_COMMA_PUBLIC_H
