// Complex Inline
// 2023
# ifndef  LISP2D_COMPLEX_INLINE_H
# define  LISP2D_COMPLEX_INLINE_H

# include "complex/private.h"
# include "fraction/public.h"
# include "complex/public.h"

inline  void  Complex_Conj  ( Complex * const mep ) {
  FractionTurnSign  ( FractionToPub ( & Complex_toPrivate  ( mep  ) -> imp2 ) ) ;
}

inline  FractionPub * Complex_Re  ( Complex * const mep ) {
  return  FractionToPub ( & Complex_toPrivate  ( mep  ) -> rep2 ) ;
}

inline  FractionPub * Complex_Im  ( Complex * const mep ) {
  return  FractionToPub ( & Complex_toPrivate ( mep ) -> imp2 ) ;
}

inline  FractionPub const * Complex_CRe ( Complex const * const mep ) {
  return  FractionCToPub  ( & Complex_toCPrivate  ( mep ) -> rep2 ) ; 
}
  
inline  FractionPub  const * Complex_CIm ( Complex const * const mep ) {
  return FractionCToPub  ( & Complex_toCPrivate  (  mep  ) -> imp2 ) ;
}

# endif // LISP2D_COMPLEX_INLINE_H
