// 2023 Complex struct pri
# ifndef  LISP2D_COMPLEX_STRUCTPRI_H
# define  LISP2D_COMPLEX_STRUCTPRI_H

# include "complex/type.h"
# include "complex/structpub.h"
# include "fraction/struct.h"

/*
Expo = R * Exp [ N ] = Complex * Exp [ Complex ]
Expo1 * Expo2 = R1 * R2 * Exp [ N1 + N2 ]
Expo1 / Expo2 = R1 / R2 * Exp [ N1 - N2 ]
Ln [ Expo ] = ( ln ( R ) + N ) * Exp [ 0 ]
Exp [ Expo ] = 1 * Exp [ R * exp( N ) ]
Expo1 + Expo2 = ( R1 + R2 * exp( N2 - N1 ) ) * Exp [ N1 ] , R1 > R2
Expo1 - Expo2 = ( R1 - R2 * exp( N2 - N1 ) ) * Exp [ N1 ] , R1 > R2
*/

struct  Lisp2D_sComplexPri {
  Fraction2 rep2  ;
  Fraction2 imp2  ;
  Complex pub ;
} ;

# endif // LISP2D_COMPLEX_STRUCTPRI_H
