// Condition
// (C)2019-23 Lisp2D

# ifndef  LISP2D_CONDIT_H
# define  LISP2D_CONDIT_H

# include "conditp.h"
# include <pthread.h>

# define  ConditionConstructor  Lisp2D_ConditionConstructor
void  ConditionConstructor  ( Condition * , pthread_condattr_t const * ) ;

# define  ConditionDestructor Lisp2D_ConditionDestructor
void  ConditionDestructor  ( Condition * ) ;

# define  ConditionSignal Lisp2D_ConditionSignal
void  ConditionSignal  ( Condition * ) ;

# include "mutex2/type.h"

# define  ConditionWait Lisp2D_ConditionWait
void  ConditionWait ( Condition * , Mutex2 * ) ;

# define  LISP2D_CONDIT(  VARNAME ) \
  Condition VARNAME = { . s = Lisp2DObjectStateRaw } ;

# endif // LISP2D_CONDIT_H
