// Lisp2D - Cons - private
// ©2011-23 by Alex Glebe

# include "cons/type.h"

# define  s_PLOCons_Cout  Lisp2D_s_PLOCons_Cout
# define  t_PLOCons_Cout  Lisp2D_t_PLOCons_Cout
typedef struct  Lisp2D_s_PLOCons_Cout t_PLOCons_Cout  ;

struct  s_PLOCons_Cout  {
  PLOCons const * const mep ;
  FuncCoutToInterpretHuman  * const funccout  ;
  PLOStream  const * const fop ;
  bool const flag2pprinted ;
  Vector  ( StackPLOP )  * const lookingp ;
} ;

# define  PLOCons_Cout  Lisp2D_PLOCons_Cout
void  PLOCons_Cout  ( t_PLOCons_Cout  const * ) ;

# define  GlobalListOfConsPairsGarbage  Lisp2DGlobalListOfConsPairsGarbage
extern  GlobalList  GlobalListOfConsPairsGarbage  ;

# define  GlobalListOfConsPairs Lisp2DGlobalListOfConsPairs
extern  GlobalList  GlobalListOfConsPairs ;

# define  GlobalListOfConsPairsGC Lisp2DGlobalListOfConsPairsGC
extern  GlobalList  GlobalListOfConsPairsGC ;

# define  ListCopyNotProtected  Lisp2D_ListCopyNotProtected
PLOCons * ListCopyNotProtected ( PLOCons  const  * mep , PLOCons * * reslastp  ) ;

# define  ListCopyProtected Lisp2D_ListCopyProtected
ParaLispObject  * ListCopyProtected ( PLOCons const * mep ) ;

# define  ListCopyNotProtected0 Lisp2D_ListCopyNotProtected0
ParaLispObject  * ListCopyNotProtected0 ( PLOCons  const * mep) ;

# define  CopyTreem1  Lisp2D_CopyTreem1
ParaLispObject  * CopyTreem1 ( PLOCons * )  ;
