// Lisp2D - consequent of atomic pointer Private
// ©2015-23 by Alex Glebe

# ifndef  LISP2D_CONSATOMIC_PRIVATE_H
# define  LISP2D_CONSATOMIC_PRIVATE_H

# include <stddef.h> // offsetof
# include <stdint.h> // uint8_t
# include "consatomic/struct.h"

# define  ConsAtomicPointerConst_cast_Private  Lisp2D_ConsAtomicPointerConst_cast_Private
inline  ConsAtomicPointerPrivat  const * ConsAtomicPointerConst_cast_Private  ( ConsAtomicPointe const * ) ;
# define  ConsAtomicPointer_cast_Private  Lisp2D_ConsAtomicPointer_cast_Private
inline  ConsAtomicPointerPrivat  * ConsAtomicPointer_cast_Private  ( ConsAtomicPointe * ) ;

# define  queueAtomicStClPrivFirst  Lisp2D_queueAtomicStClPrivFirst
extern  ConsAtomicPointe * queueAtomicStClPrivFirst ;

# define  queueAtomicStClPrivLast Lisp2D_queueAtomicStClPrivLast
extern  ConsAtomicPointe * queueAtomicStClPrivLast  ;

inline  ConsAtomicPointerPrivat  const * ConsAtomicPointerConst_cast_Private  ( ConsAtomicPointe const * const p ) {
  return  ( ConsAtomicPointerPrivat  const * ) ( ConsAtomicPointerConst_cast_bytep ( p ) -
    offsetof ( ConsAtomicPointerPrivat , pub ) ) ;
}

inline  ConsAtomicPointerPrivat  * ConsAtomicPointer_cast_Private  ( ConsAtomicPointe * const p ) {
  return  ( ConsAtomicPointerPrivat  * ) ( ConsAtomicPointer_cast_bytep ( p ) -
    offsetof ( ConsAtomicPointerPrivat , pub ) ) ;
}

# endif // LISP2D_CONSATOMIC_PRIVATE_H
