// Lisp2D - deque public functions declaration
// ©2020-3 by Alex Glebe
# include "deque/public.h"
# include "deque/type-wchar.h"

inline  void  Deque_Init ( WChar ) ( Deque ( WChar ) * ) ;
void  Deque_Destr ( WChar ) ( Deque ( WChar ) * ) ;
void  Deque_Resize  ( WChar ) ( Deque ( WChar ) * , size_t count ) ;

inline  void  Deque_Init ( WChar ) ( Deque ( WChar ) * const me ) {
  DequeVoidInit ( me ) ;
}

Deque_End_Decl  ( WChar )
Deque_CEnd_Decl  ( WChar )
Deque_REnd_Decl  ( WChar )
Deque_CREnd_Decl  ( WChar )
Deque_Begin_Decl  ( WChar )
Deque_CBegin_Decl  ( WChar )
Deque_RBegin_Decl ( WChar )
Deque_CRBegin_Decl  ( WChar )
Deque_Push_back_Decl ( WChar , wchar_t )
Deque_Push_front_Decl ( WChar , wchar_t )
Deque_At_Decl  ( WChar , wchar_t )
Deque_AtFast_Decl  ( WChar , wchar_t )
inline  Deque_Const_Cast_Decl ( WChar )
inline  Deque_AtConstDecl ( WChar , wchar_t )
inline  Deque_AtFastConstDecl ( WChar , wchar_t )
inline  Deque_Clear_Decl ( WChar )
inline  Deque_Empty_Decl ( WChar )
inline  Deque_FrontConstDecl ( WChar , wchar_t )
inline  Deque_BackConstDecl ( WChar , wchar_t )
inline  Deque_Swap_Decl ( WChar )

inline  Deque_Const_Cast_Templ  ( WChar )
inline  Deque_AtConstTempl ( WChar , wchar_t )
inline  Deque_AtFastConstTempl ( WChar , wchar_t )
Deque_Size_Decl( WChar )
inline  Deque_Clear_Templ ( WChar )
inline  Deque_EmptyTempl  ( WChar )
Deque_InitSize_Decl  ( WChar )
Deque_Pop_back_Decl ( WChar , wchar_t )
Deque_Pop_front_Decl ( WChar , wchar_t )
Deque_Front_Decl  ( WChar , wchar_t )
inline  Deque_FrontConstTempl ( WChar , wchar_t )
Deque_Back_Decl  ( WChar , wchar_t )
inline  Deque_BackConstTempl ( WChar , wchar_t )
Deque_ResizeVal_Decl  ( WChar , wchar_t )
inline  Deque_SwapTempl ( WChar )
Deque_ConstIterator_NotEq_Decl ( WChar )
Deque_ConstIterator_NotEqIterator_Decl ( WChar )

# include "deque/struct.h"
# include "castb.h"

inline  Deque_Iterator_Place_Decl ( WChar , wchar_t )
inline  Deque_ConstIterator_Place_Decl ( WChar , wchar_t )

inline  Deque_Iterator_Place_Templ ( WChar , wchar_t , voidp_cast_wcharp )
inline  Deque_ConstIterator_Place_Templ ( WChar , wchar_t , const_voidp_cast_wcharp )

Deque_ConstIterator_Inc_Decl  ( WChar )
Deque_ConstIterator_Dec_Decl  ( WChar )
Deque_ConstIterator_Add_Decl  ( WChar )
Deque_Iterator_Inc_Decl  ( WChar )
Deque_Iterator_Dec_Decl  ( WChar )
Deque_Iterator_Add_Decl  ( WChar )

Deque_Erase_Decl( WChar )
