// Lisp2D - Deque type
// ©2023 by Alex Glebe

struct  Lisp2D_sDequeVoid ;

typedef struct  Lisp2D_sDequeVoid  Lisp2D_DequeVoid ;
typedef Lisp2D_DequeVoid  DequeVoid ;

# define  sDequeVoidIterator  Lisp2D_sDequeVoidIterator
struct  sDequeVoidIterator ;
# define  DequeVoidIterator Lisp2D_DequeVoidIterator
typedef struct  sDequeVoidIterator  DequeVoidIterator ;

# define  Lisp2D_Deque( T ) Lisp2D_Deque_ ## T 
# define  Deque(  T ) Lisp2D_Deque  ( T )

# define  Lisp2D_DequeTypedef(  T ) typedef struct  Lisp2D_sDequeVoid  Deque  ( T ) ;
# define  DequeTypedef( T ) Lisp2D_DequeTypedef (  T )

# define  Lisp2D_DequeIterator( T ) Lisp2D_DequeIterator_ ## T 
# define  DequeIterator(  T ) Lisp2D_DequeIterator  ( T )

# define  Lisp2D_DequeIteratorTypedef(  T ) \
  typedef struct  sDequeVoidIterator DequeIterator  ( T ) ;
# define  DequeIteratorTypedef( T ) Lisp2D_DequeIteratorTypedef (  T )

# define  Lisp2D_DequeConstIterator( T ) Lisp2D_DequeConstIterator_ ## T 
# define  DequeConstIterator(  T ) Lisp2D_DequeConstIterator  ( T )

# define  Lisp2D_DequeConstIteratorTypedef(  T ) \
  typedef struct  sDequeVoidConstIterator DequeConstIterator  ( T ) ;
# define  DequeConstIteratorTypedef( T ) Lisp2D_DequeConstIteratorTypedef (  T )

# define  Lisp2D_DequeReverseIterator( T ) Lisp2D_DequeReverseIterator_ ## T 
# define  DequeReverseIterator(  T ) Lisp2D_DequeReverseIterator  ( T )

# define  Lisp2D_DequeReverseIteratorTypedef(  T ) \
  typedef struct  sDequeVoidReverseIterator DequeReverseIterator  ( T ) ;
# define  DequeReverseIteratorTypedef( T ) Lisp2D_DequeReverseIteratorTypedef (  T )

# define  Lisp2D_DequeConstReverseIterator( T ) \
  Lisp2D_DequeConstReverseIterator_ ## T 
# define  DequeConstReverseIterator(  T ) Lisp2D_DequeConstReverseIterator  ( T )

# define  Lisp2D_DequeConstReverseIteratorTypedef(  T ) \
  typedef struct  sDequeVoidConstReverseIterator \
    DequeConstReverseIterator  ( T ) ;
# define  DequeConstReverseIteratorTypedef( T ) \
  Lisp2D_DequeConstReverseIteratorTypedef (  T )
