// Lisp2D - Environment struct
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_ENV_STRUCT_H
# define  LISP2D_ENV_STRUCT_H

struct  sLisp2DEnvironmentLayerValueAndFlagConst {
  ParaLispObject  * value ;
  bool  flagconst ;
} ;

# include "env/type.h"

LISP2DMAPNODE (  PLOValueFlagConst  , ParaLispObject *  , EnvironmentLayerValueAndFlagConst  )
LISP2DMAPSTACK (  PLOValueFlagConst )
LISP2DMAP (  PLOValueFlagConst , ParaLispObject * )

# include "passage/struct.h"

struct  sLisp2DEnvironmentLayer  {
  // lock if adds new symbol
  // change,get value - free access for all threads
  struct  Lisp2DPassagePrivate  passagec  ;
  Map ( PLOValueFlagConst ) maplinks  ;
} ;

struct s_Lisp2D_PLOEnvironmentLayer {
  ParaLispObject  plo ;
  EnvironmentLayer  envlay  ;
} ;

struct  Lisp2D_sEnvironment {
  // env=((lock . #()|nil) .. (lock . #()|nil))
  ParaLispObject  * env ;
  ParaLispObject  * namespaceproplist  ;
} ;

struct  sPLOEnvC {
  ParaLispObject  plo ;
  Environment env ;
} ;

# endif // LISP2D_ENV_STRUCT_H
