// Lisp2D - Fraction number private Inline
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_FRACTION_INLINEPRI_H
# define  LISP2D_FRACTION_INLINEPRI_H

# include "fraction/private.h"

inline  uint8_t const * FractionPubC_cast_bytep  ( FractionPub const * const p ) {
  return  ( uint8_t const * ) p ;
}

inline  Fraction2 const * bytepc_cast_Fraction  ( uint8_t const * const p ) {
  return  ( Fraction2 const * ) p ;
}

# include "fraction/struct.h"

inline  Fraction2 const * Fraction_toCPrivate ( FractionPub const * const p ) {
  return  bytepc_cast_Fraction ( FractionPubC_cast_bytep  ( p ) - offsetof ( Fraction2 , pub ) ) ;
}

inline  Fraction2 * bytep_cast_Fraction  ( uint8_t * const p ) {
  return  ( Fraction2 * ) p ;
}

inline  uint8_t * FractionPub_cast_bytep  ( FractionPub * const p ) {
  return  ( uint8_t * ) p ;
}

inline  Fraction2 * Fraction_toPrivate ( FractionPub * const p ) {
  return  bytep_cast_Fraction ( FractionPub_cast_bytep  ( p ) - offsetof ( Fraction2 , pub ) ) ;
}

# endif // LISP2D_FRACTION_INLINEPRI_H
