// Lisp2D GlobalListMember Inline
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_GLOBALLISTM_INLINE_H
# define  LISP2D_GLOBALLISTM_INLINE_H

# include "globallistm/public.h"

inline  GlobalListMember *  GlobalListMemberNext  ( GlobalListMember const * const me ) {
  return me  -> next ;
}

inline  VirtualTypePointer GlobalListMemberVirt  ( GlobalListMember const * const  me ) {
  return me  -> vaddr ;
}

# include "virttype/public.h"

inline  void  GlobalListMemberConstr ( GlobalListMember * const me  ) {
  me  ->  prev  = 0 ;
  me  ->  next  = 0 ;
  VirtualTypePointer * const  vtp = & me  ->  vaddr ;
  VirtualTypePointerConstr  ( vtp ) ;
}

inline  void  GlobalListMemberConstrFB ( GlobalListMember * const me  , VirtualTypePointer const  fb  ) {
  me  ->  prev  = 0  ;
  me  ->  next  = 0  ;
  me  ->  vaddr = fb ;
}

# endif
