// Lisp2D GlobalListMember public
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_GLOBALLISTM_PUBLIC_H
# define  LISP2D_GLOBALLISTM_PUBLIC_H

# include "globallistm/type.h"

# define  GlobalListMemberNext  Lisp2DGlobalListMemberNext
inline  GlobalListMember *  GlobalListMemberNext  ( GlobalListMember const * me ) ;

# define  GlobalListMemberVirt  Lisp2DGlobalListMemberVirt
inline  VirtualTypePointer GlobalListMemberVirt  ( GlobalListMember const * me ) ;
# define  GlobalListMemberConstr  Lisp2DGlobalListMemberConstr
inline  void  GlobalListMemberConstr ( GlobalListMember * me  ) ;

# include "virttype/type.h"

# define  GlobalListMemberConstrFB  Lisp2DGlobalListMemberConstrFB
inline  void  GlobalListMemberConstrFB ( GlobalListMember * me  , VirtualTypePointer fb  ) ;

# endif // LISP2D_GLOBALLISTM_PUBLIC_H
