// Lisp2D GlobalList Struct
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_GLOBALLISTP_STRUCT_H
# define  LISP2D_GLOBALLISTP_STRUCT_H
# include "define.h"
# include "atomic_mutex.h"
# include "globallistm/type.h"

struct sLisp2DGlobalList {
# ifdef LISP2D_DEBUG
  Lisp2DObjectState s ;
# endif
  // ! to rename to priv_amutex
  Lisp2D_atomic_mutex amutex ;
  // ! to rename to priv_first
  GlobalListMember  *  first ;  // may be nullptr
  // ! under Lock change value ++ or -- or else
  size_t  count_private ;
} ;

# endif // LISP2D_GLOBALLISTP_STRUCT_H
