// Lisp2D inner history Public
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_INNER_HISTORY_PUBLIC_H
# define  LISP2D_INNER_HISTORY_PUBLIC_H
# include "define.h"
# ifdef  LISP2D_INNERHISTORY
# include "inner-history/type.h"
# define  InnerHistoryConstructorDefault  Lisp2D_InnerHistoryConstructorDefault
void  InnerHistoryConstructorDefault  ( struct Lisp2DInnerHistory * ) ;
# include "inner-history/enum.h"
# define  InnerHistoryConstructorSize Lisp2D_InnerHistoryConstructorSize
void  InnerHistoryConstructorSize ( struct Lisp2DInnerHistory * , enum  Lisp2DtypeSizeStartInnerHistory ) ;
# define  InnerHistoryConstructorCopy Lisp2DInnerHistoryConstructorCopy
void  InnerHistoryConstructorCopy  ( struct Lisp2DInnerHistory * , struct Lisp2DInnerHistory const * ) ;
# define  InnerHistoryDestructor  Lisp2DInnerHistoryDestructor
void  InnerHistoryDestructor  ( struct Lisp2DInnerHistory * ) ;
# define  InnerHistoryResize  Lisp2DInnerHistoryResize
void  InnerHistoryResize  ( struct Lisp2DInnerHistory * , size_t ) ;
# define  InnerHistoryPush  Lisp2DInnerHistoryPush
void  InnerHistoryPush  ( struct Lisp2DInnerHistory * , void  const  * ) ;
# define  InnerHistoryShow  Lisp2DInnerHistoryShow
void  InnerHistoryShow  ( struct Lisp2DInnerHistory * ) ;
# include "atomic_mutex.h"
# define  InnerHistoryMutex Lisp2DInnerHistoryMutex
inline  Lisp2D_atomic_mutex const * InnerHistoryMutex ( struct  Lisp2DInnerHistory  const * ) ;
extern  struct Lisp2DInnerHistory  Lisp2DinnerHistory  ;
# endif // LISP2D_INNERHISTORY
# endif // LISP2D_INNER_HISTORY_PUBLIC_H
