// Lisp2D inner history Struct
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_INNERHISTORY_STRUCT_H
# define  LISP2D_INNERHISTORY_STRUCT_H
# include "define.h"
# ifdef  LISP2D_INNERHISTORY
# include <pthread.h>
struct  Lisp2DInnerHistoryStep  {
  pthread_t th_id  ;
  wchar_t const ( * place ) [ ] ;
  // ! to add string size ?
  // ? or struct CWStr{wchar const (*)[] , size_t}
  //size_t  size_place  ;
} ;

# include "define.h"
# ifdef LISP2D_DEBUG
# include "inner-history/enum.h"
# endif

# include "atomic_mutex.h"

struct Lisp2DInnerHistory  {
  Lisp2D_atomic_mutex amutex  ;
  struct Lisp2DInnerHistoryStep ( * arrayqueue ) [ ] ;
  size_t  arraysize ;
  size_t  indexto  ;
  bool  flagfull  ;
  // ! to add flaghasdatahole : if (indexto == 0 and flaghasdatahole == false and
  //  flagfull == true ) => flaghasdatahole := true
# ifdef LISP2D_DEBUG
  enum  Lisp2DtypeInnerHistoryState status  ;
# endif
} ;
# endif // LISP2D_INNERHISTORY
# endif // LISP2D_INNERHISTORY_STRUCT_H
