// Lisp2D - List template private
// ©2022-3 by Alex Glebe

# ifndef  LISP2D_LIST_PRIVATE_H
# define  LISP2D_LIST_PRIVATE_H

# include <stddef.h> // offsetof

# define  Lisp2D_ListToConstPrivate(  N ) Lisp2D_ListToConstPrivate_  ##  N

# define  LISP2DLISTTOCONSTPRIVATEDECL( NAME  ) \
Lisp2D_ListPri ( NAME ) const * \
  Lisp2D_ListToConstPrivate ( NAME ) ( Lisp2D_List ( NAME ) const * ) ;

# define  LISP2DLISTTOCONSTPRIVATEBODY( NAME  ) \
Lisp2D_ListPri ( NAME ) const * \
  Lisp2D_ListToConstPrivate ( NAME ) ( Lisp2D_List ( NAME ) const * const p ) { \
  return  ( Lisp2D_ListPri ( NAME ) const * ) ( ( ( uint8_t * ) p ) - \
    offsetof  ( Lisp2D_ListPri ( NAME ) , pub ) ) ; \
}

# define  Lisp2D_ListToPrivate( N ) Lisp2D_ListToPrivate_ ##  N
    
# define  LISP2DLISTTOPRIVATEDECL( NAME  ) \
Lisp2D_ListPri ( NAME ) * \
  Lisp2D_ListToPrivate ( NAME ) ( Lisp2D_List ( NAME ) * ) ;
    
# define  LISP2DLISTTOPRIVATEBODY( NAME  ) \
Lisp2D_ListPri ( NAME ) * \
  Lisp2D_ListToPrivate ( NAME ) ( Lisp2D_List ( NAME ) * const p ) { \
  return  ( Lisp2D_ListPri ( NAME ) * ) ( ( ( uint8_t * ) p ) - \
    offsetof  ( Lisp2D_ListPri ( NAME ) , pub ) ) ; \
}

# define  Lisp2D_ListNodeToConstPrivate(  N ) Lisp2D_ListNodeToConstPrivate_  ##  N
    
# define  LISP2DLISTNODETOCONSTPRIVATEDECL( NAME  ) \
Lisp2D_ListNodePri ( NAME ) const * \
  Lisp2D_ListNodeToConstPrivate ( NAME ) ( Lisp2D_ListNode ( NAME ) const * ) ;
    
# define  LISP2DLISTNODETOCONSTPRIVATEBODY( NAME  ) \
Lisp2D_ListNodePri ( NAME ) const * Lisp2D_ListNodeToConstPrivate ( NAME ) ( \
  Lisp2D_ListNode ( NAME ) const * const p ) { \
  return  ( Lisp2D_ListNodePri ( NAME ) const * ) ( ( ( uint8_t * ) p ) - \
    offsetof  ( Lisp2D_ListNodePri ( NAME ) , pub ) ) ; \
}

# define  Lisp2D_ListNodeToPrivate( N ) Lisp2D_ListNodeToPrivate_ ##  N
    
# define  LISP2DLISTNODETOPRIVATEDECL( NAME  ) \
Lisp2D_ListNodePri ( NAME ) * Lisp2D_ListNodeToPrivate ( NAME ) ( Lisp2D_ListNode ( NAME ) * ) ;
    
# define  LISP2DLISTNODETOPRIVATEBODY( NAME  ) \
Lisp2D_ListNodePri ( NAME ) * \
  Lisp2D_ListNodeToPrivate ( NAME ) ( Lisp2D_ListNode ( NAME ) * const p ) { \
  return  ( Lisp2D_ListNodePri ( NAME ) * ) ( ( ( uint8_t * ) p ) - \
    offsetof  ( Lisp2D_ListNodePri ( NAME ) , pub ) ) ; \
}

# endif //  LISP2D_LIST_PRIVATE_H
