// Lisp2D - List template struct private
// ©2022-3 by Alex Glebe

# ifndef  LISP2D_LIST_STRUCTPRI_H
# define  LISP2D_LIST_STRUCTPRI_H

# include "list/struct.h"

# define LISP2D_LISTPRI_STRUCT( NAME  ) \
struct  sLisp2D_ListPri ( NAME  ) { \
  Lisp2D_ListNode ( NAME  ) * first ; \
  Lisp2D_ListNode ( NAME  ) * last  ; \
  Lisp2D_List ( NAME  ) pub ; \
} ;

# define LISP2D_LISTNODEPRI_STRUCT( NAME  , TYPE ) \
struct  sLisp2D_ListNodePri ( NAME  ) { \
  TYPE  val ; \
  Lisp2D_ListNode ( NAME  ) * next ; \
  Lisp2D_ListNode ( NAME  ) pub ; \
} ;

# endif //  LISP2D_LIST_STRUCTPRI_H
