// Lisp2D - Universal method Min , Max
//            for many Types
// ©2017-23 by Alex Glebe

# ifndef  LISP2D_MINMAX_H
# define  LISP2D_MINMAX_H

# include "taskforthread.h"
# include "funccomptype.h"

// (1 min ) -> 1
// (1 min 2) -> 1
// (1 min 2 3)  -> 1
// (1 min 2 3 0)  -> 0
// (1 min 1/0)  -> 1
// (1 min -1/0)  -> -1/0
// (1 min 2 3 0/0)  -> NIL
// FuncMinMaxP(stcl) must check type  and push exception
// This argument (left) must to be with checked type  
# define  bimUniversalMinMax  Lisp2DbimUniversalMinMax
TaskForThread bimUniversalMinMax  ( FuncComparisonP f , StackClusterPrivate * ) ;

# endif // LISP2D_MINMAX_H
