// Lisp2D - users objects
// ©2006-23 by Alex Glebe

# include "define.h"
# ifdef  LISP2D_CONSTRSTAT
# include <stddef.h>
# define  PLOObject_constrstat_Inc  Lisp2D_PLOObject_constrstat_Inc
void  PLOObject_constrstat_Inc  ( void  ) ;
# define  PLOObject_constrstat_Value  Lisp2D_PLOObject_constrstat_Value
size_t  PLOObject_constrstat_Value  ( void  ) ;
# endif // LISP2D_CONSTRSTAT

# include "object/type.h"

# define  PLOObject_Destr Lisp2D_PLOObject_Destr
void  PLOObject_Destr ( PLOObject * ) ;

# include "env/type.h"

# define  PLOObject_SetNewContext Lisp2D_PLOObject_SetNewContext
void  PLOObject_SetNewContext ( PLOObject * , PLOEnvironmentLayer * ) ;

# include "plo/type.h"

# define  PLOObject_SetClassName  Lisp2D_PLOObject_SetClassName
void  PLOObject_SetClassName ( PLOObject * me , ParaLispObject * ) ;

# include "plo/struct.h"

# define  Objectp Lisp2D_Objectp
inline  bool  Objectp ( ParaLispObject const * ) ;

# define  ParaLispObjectToPLOObjectConst Lisp2DParaLispObjectToPLOObjectConst
inline  PLOObject const * ParaLispObjectToPLOObjectConst ( ParaLispObject const * ) ;

# define  ParaLispObjectToPLOObject Lisp2DParaLispObjectToPLOObject
inline  PLOObject * ParaLispObjectToPLOObject ( ParaLispObject * ) ;

# include "plostream/type.h"

# define  PLOObject_staticCoutToInterpret  Lisp2D_PLOObject_staticCoutToInterpret
void  PLOObject_staticCoutToInterpret ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# define  PLOObject_staticCoutToHuman Lisp2D_PLOObject_staticCoutToHuman
void  PLOObject_staticCoutToHuman ( ParaLispObject const * me ,
  PLOStream  const * s , bool flag2pprinted  , Vector ( StackPLOP ) * h ) ;

# define  PLOObject_staticisBADCopyPrivate  Lisp2D_PLOObject_staticisBADCopyPrivate
bool  PLOObject_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# define  PLOObject_staticGCDeclareContent  Lisp2D_PLOObject_staticGCDeclareContent
void  PLOObject_staticGCDeclareContent ( ParaLispObject * ) ;

# define  PLOObject_staticTypeOf  Lisp2D_PLOObject_staticTypeOf
ParaLispObject  * PLOObject_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOObject_staticClassParents  Lisp2D_PLOObject_staticClassParents
ParaLispObject  * PLOObject_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOObject_staticClassDef  Lisp2D_PLOObject_staticClassDef
ParaLispObject  * PLOObject_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOObject_staticContext Lisp2D_PLOObject_staticContext
ParaLispObject  * PLOObject_staticContext ( ParaLispObject const * ) ;

# define  PLOObject_staticDestr Lisp2D_PLOObject_staticDestr
void PLOObject_staticDestr  ( ParaLispObject * ) ;

# define  PLOObject_SetClassDef Lisp2D_PLOObject_SetClassDef
inline  void  PLOObject_SetClassDef ( PLOObject * const me , ParaLispObject  * const cdp ) ;

# define  PLOObject_Init  Lisp2D_PLOObject_Init
void  PLOObject_Init ( PLOObject * ) ;
