// Lisp2D - PArray
// ©2023 by Alex Glebe

# ifndef  LISP2D_PARRAY_H
# define  LISP2D_PARRAY_H
/*
declare Lisp2DPArrayintp :

PArrayStruct ( int * , intp )

shortcut :

# define  PArrayintp  Lisp2DPArrayintp

from array :

int * arr[3]={&a,&b,&c};
PArrayintp  pa = { & arr } ;

pass to function : funct ( PArrayintp ) 

funct( PArrayintp { (int*(*)[])&arr });

to use value :

(*(ap.p))[1]

first member address :

&((*(ap.p))[0])

*/
# define  Lisp2DsPArray( n ) Lisp2DsPArray  ##  n
# define  sPArray  Lisp2DsPArray

# define  Lisp2DPArray( n ) Lisp2DPArray  ##  n
# define  PArray  Lisp2DPArray

# define Lisp2DPArrayStruct( t  , n ) \
  typedef struct sPArray ( n )  PArray ( n ) ;  \
  struct sPArray ( n ) { \
    t ( * p ) [ ] ; \
  } ;
# define  PArrayStruct  Lisp2DPArrayStruct

# include <wchar.h>

PArrayStruct  ( wchar_t const , _wchar_c )
# define  PArray_wchar_c  Lisp2DPArray_wchar_c

PArrayStruct  ( wchar_t const volatile , _wchar_cv )
# define  PArray_wchar_cv  Lisp2DPArray_wchar_cv

PArrayStruct  ( char const , _char_c )
# define  PArray_char_c  Lisp2DPArray_char_c

# endif // LISP2D_PARRAY_H
