// Passage private
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_PASSAGE_PRIVATE_H
# define  LISP2D_PASSAGE_PRIVATE_H

# define  passageGCC  Lisp2DpassageGCC
extern  struct  Lisp2DPassagePrivate passageGCC  ;  

# include <stdint.h>
# include <stddef.h>

# define  Passage_cast_bytep  Lisp2D_Passage_cast_bytep
inline  uint8_t * Passage_cast_bytep ( struct  Lisp2DsPassagePub * ) ;
# define  bytep_cast_PassagePri  Lisp2D_bytep_cast_PassagePri
inline  struct  Lisp2DPassagePrivate * bytep_cast_PassagePri ( uint8_t * ) ;
# define  Passage_toPrivate  Lisp2D_Passage_toPrivate
inline  struct  Lisp2DPassagePrivate * Passage_toPrivate ( struct  Lisp2DsPassagePub * ) ;
# define  PassageC_cast_bytep  Lisp2D_PassageC_cast_bytep
inline  uint8_t const * PassageC_cast_bytep ( struct  Lisp2DsPassagePub const * ) ;
# define  bytep_cast_CPassagePri  Lisp2D_bytep_cast_CPassagePri
inline  struct  Lisp2DPassagePrivate const * bytep_cast_CPassagePri ( uint8_t const * ) ;
# define  Passage_toCPrivate  Lisp2D_Passage_toCPrivate
inline  struct  Lisp2DPassagePrivate const * Passage_toCPrivate ( struct  Lisp2DsPassagePub const * ) ;

// code

inline  uint8_t * Passage_cast_bytep ( struct  Lisp2DsPassagePub * const p ) {
  return  ( uint8_t * ) p ;
}

inline  struct  Lisp2DPassagePrivate * bytep_cast_PassagePri ( uint8_t * const p ) {
  return  ( struct  Lisp2DPassagePrivate * ) p ;
}

inline  struct  Lisp2DPassagePrivate * Passage_toPrivate ( struct  Lisp2DsPassagePub * const p ) {
  return  bytep_cast_PassagePri ( Passage_cast_bytep ( p ) - offsetof ( struct  Lisp2DPassagePrivate , pub ) ) ;
}

inline  uint8_t const * PassageC_cast_bytep ( struct  Lisp2DsPassagePub const * const p ) {
  return  ( uint8_t const * ) p ;
}

inline  struct  Lisp2DPassagePrivate const * bytep_cast_CPassagePri ( uint8_t const * const p ) {
  return  ( struct  Lisp2DPassagePrivate const * ) p ;
}

inline  struct  Lisp2DPassagePrivate const * Passage_toCPrivate ( struct  Lisp2DsPassagePub const * const p ) {
  return  bytep_cast_CPassagePri ( PassageC_cast_bytep ( p ) - offsetof ( struct  Lisp2DPassagePrivate , pub ) ) ;
}

# endif // LISP2D_PASSAGE_PRIVATE_H
