// Parallel Lisp Object
// Lisp2D 2022-3
# ifndef  LISP2D_PLO_STRUCT_H
# define  LISP2D_PLO_STRUCT_H
# include <stdbool.h>
# include "define.h"
# include "globallist.h"
# include "plo/type.h"
# include "globallistm/struct.h"
# include "object-state.h"

// ! to make private struct

// root class for objects
struct  sLisp2D_ParaLispObject  {
  GlobalListMember  base  ;
  VirtualTypePointer vaddr ; // point to struct with ParaLispObject field
//private :
  bool  flagGCPassed  ;
  // true - to stop modifying
  bool  flagConst ;
  // true - to stop free
  bool  flagStatic  ;
# ifdef LISP2D_DEBUG
  Lisp2DObjectState objstate ;
# endif
} ;

# endif // LISP2D_PLO_STRUCT_H
