// Lisp2D - PLOStream - type
// ©2021-3 by Alex Glebe

# define  Lisp2DsPLOStream  Lisp2D_Lisp2DsPLOStream
typedef struct Lisp2DsPLOStream  Lisp2DPLOStream ;
typedef Lisp2DPLOStream PLOStream ;

# include <sys/types.h> // mode_t

typedef void  (  * Lisp2D_MKDirFuncP ) ( mode_t * ) ;
typedef Lisp2D_MKDirFuncP MKDirFuncP  ;

# include "stack-plop.h"

typedef void  ( FuncCoutToInterpretHuman  ) ( ParaLispObject  const * me  ,
  PLOStream const * s , bool  const * flag2pprinted , Vector  ( StackPLOP ) * history ) ;

typedef FuncCoutToInterpretHuman  * FuncCoutToInterpretHumanP ;

# define  sOpenModes Lisp2DsOpenModes
typedef struct  sOpenModes  Lisp2D_OpenModes ;
typedef Lisp2D_OpenModes  OpenModes ;

typedef void  ( * Lisp2DOpenModefFuncP ) ( OpenModes * ) ;
typedef Lisp2DOpenModefFuncP  OpenModefFuncP  ;

# include "map.h"

LISP2DMAPCOMPTYPE ( FlessOpenModes  , ParaLispObject  * )
LISP2DMAPCOMPTYPE ( FlessMkdirModes , ParaLispObject  * )

LISP2DMAPNODETYPE ( FlessOpenModes  )
LISP2DMAPSTACKTYPE  ( FlessOpenModes  )
LISP2DMAPNODETYPE ( FlessMkdirModes )
LISP2DMAPSTACKTYPE  ( FlessMkdirModes )
