// Lisp2D - Stack of wide characters
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_STACK_WIDECHAR_H
# define  LISP2D_STACK_WIDECHAR_H

# include "stack-define.h"
LISP2DSTACKSTRUCTTYPE ( WideChar  )
LISP2DSTACKSTRUCT ( WideChar , wchar_t volatile )
LISP2D_PROTO_STACK_FREE ( WideChar )
// ! to proto and push down
inline  LISP2DSTACKPOPVALUE ( WideChar , wchar_t  )
LISP2DPROTOSTACKISEQ ( WideChar , wchar_t  )
LISP2DPROTOSTACKRESIZE ( WideChar )
LISP2DPROTOSTACKRESIZE1 ( WideChar )
LISP2DPROTOSTACKCLEAR  ( WideChar )
LISP2DPROTOSTACKELTCOPY  ( WideChar , wchar_t )
LISP2DPROTOSTACKPUSHFRONTVALUE  ( WideChar , wchar_t )
LISP2DPROTOSTACKPUSHBYVALUE  ( WideChar , wchar_t )
LISP2DPROTOSTACKINSERTFRONT  ( WideChar , wchar_t )
LISP2DPROTOSTACKSET  ( WideChar , wchar_t )
LISP2DPROTOSTACKDESTRUCTOR  ( WideChar )
LISP2DPROTOSTACKSWAP  ( WideChar , wchar_t )
LISP2DPROTOSTACKPOP ( WideChar )
LISP2DPROTOSTACKBACKCOPY ( WideChar , wchar_t  )
LISP2DPROTOSTACKREMOVEFRONT  ( WideChar , wchar_t  )
LISP2DPROTOSTACKAT  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKATCOPY  ( WideChar , wchar_t  )
LISP2DPROTOSTACKFRONTCOPY  ( WideChar , wchar_t  )
LISP2DPROTOSTACKCEND  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKCBACK  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKBACK  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKCREND  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKCRBEGIN  ( WideChar , wchar_t volatile )
LISP2DPROTOSTACKEND  ( WideChar , wchar_t volatile )
inline LISP2DSTACKCONSTRUCTORDEFAULT ( WideChar )
inline LISP2DSTACKCONSTRONE ( WideChar , wchar_t )
LISP2DPROTOSTACKCONSTRUCTORCOPY  ( WideChar )
LISP2DDECLARESTACKCONSTRUCTORMOVE ( WideChar , wchar_t )
LISP2DPROTOSTACKCAT ( WideChar , wchar_t volatile )

# endif // LISP2D_STACK_WIDECHAR_H
