// Lisp2D - Stack universal types Enum
// ©2019-23 by Alex Glebe

# ifndef LISP2D_STACK_ENUM_H
# define LISP2D_STACK_ENUM_H

// size of stack , Linux 64bits nature 8Mb
enum { Lisp2DThreadStackSIZE = 0x800000U } ;

# define  Lisp2D_StackType(  T ) Lisp2D_StackType_  ##  T
# define  StackType Lisp2D_StackType
// types of all different members in stack
enum { Lisp2DStackTypeULong , Lisp2DStackTypeSLong , Lisp2DStackTypeStringChar ,
  Lisp2DStackTypeStringWideChar , Lisp2DStackTypeFraction ,
  Lisp2DStackTypeStackUnsInt ,  Lisp2DStackTypeStackPLOP  ,
  StackType ( StackPLOPC ) ,
  StackType ( Deque_WChar  ) ,  StackType ( Deque_Byte  ) ,
  StackType ( VectorUnsignedLongInt ) , StackType ( ComplexPri ) ,
  StackType ( CConsIterator ) ,
  Lisp2DStackTypeSIZE
} ;

# endif // LISP2D_STACK_ENUM_H
