// Lisp2D - Stack universal types Type
// ©2019-23 by Alex Glebe

# include <stdint.h>

typedef  uint32_t Lisp2DThreadStackSizeType ;

typedef  uint32_t Lisp2DThreadStackPointerType ;

typedef Lisp2DThreadStackPointerType  ThreadStackPointerType  ;

// type for all member types to count (255 types => 8 bits)
typedef uint8_t Lisp2DThreadStackTypeType ;

typedef Lisp2DThreadStackTypeType ThreadStackTypeType ;

typedef void  ( * Lisp2D_StackDestructorType  ) ( void  * ) ;

typedef Lisp2D_StackDestructorType  StackDestructorType ;
