// Lisp2D - Stat private
// ©2017-23 by Alex Glebe
# ifndef  LISP2D_STAT_PRIVATE_H
# define  LISP2D_STAT_PRIVATE_H
# include <sys/stat.h>

# include "plo/struct.h"
# include "stat/structpri.h"
# include "stat/public.h"

# define  plostatc_cast_bytec Lisp2D_plostatc_cast_bytec
inline  uint8_t const * plostatc_cast_bytec ( PLOStat const * ) ;
# define  bytec_cast_plostatpric Lisp2D_bytec_cast_plostatpric
inline  PLOStatPri const * bytec_cast_plostatpric ( uint8_t const * ) ;
# define  PLOStat_toCPrivate  Lisp2D_PLOStat_toCPrivate
inline  PLOStatPri  const * PLOStat_toCPrivate  ( PLOStat const * ) ;
# define  plostat_cast_byte Lisp2D_plostat_cast_byte
inline  uint8_t * plostat_cast_byte ( PLOStat * ) ;
# define  byte_cast_plostatpri Lisp2D_byte_cast_plostatpri
inline  PLOStatPri * byte_cast_plostatpri ( uint8_t * ) ;
# define  PLOStat_toPrivate  Lisp2D_PLOStat_toPrivate
inline  PLOStatPri * PLOStat_toPrivate  ( PLOStat * ) ;
  
# endif // LISP2D_STAT_PRIVATE_H
