// StackCluster Queue
// (C)2023
# include "consatomic/public.h"
# include "stcl/public.h"
# include "stcl/inline.h"

# define  StackClusterSwapHandToQueue Lisp2DStackClusterSwapHandToQueue
inline  void  StackClusterSwapHandToQueue ( StackClusterPrivate * , ConsAtomicPointe * * ) ;
# define  StackClusterClearHandToQueue  Lisp2DStackClusterClearHandToQueue
void  StackClusterClearHandToQueue  ( StackClusterPrivate * ) ;
# define  StackClusterMyHand  Lisp2DStackClusterMyHand
inline  ConsAtomicPointe * StackClusterMyHand  ( StackClusterPrivate * ) ;
# define  StackClusterSetNextQueue  Lisp2DStackClusterSetNextQueue
void  StackClusterSetNextQueue  ( StackClusterPrivate * , ConsAtomicPointe * ) ;
# define  StackClusterSetFirstQueue Lisp2DStackClusterSetFirstQueue
void  StackClusterSetFirstQueue ( StackClusterPrivate * ) ;

inline  void  StackClusterSwapHandToQueue ( StackClusterPrivate * const me , ConsAtomicPointe * * const handpointernew  ) {
  ConsAtomicPointe * * const handpointerold = StackClusterPrivate_handtoqueuelink ( me ) ;
  ConsAtomicPointe * const tmp = * handpointerold ;
  * handpointerold  = * handpointernew  ;
  * handpointernew  = tmp ;
}

inline  ConsAtomicPointe * StackClusterMyHand  ( StackClusterPrivate * const me ) {
  return StackClusterPrivate_handtoqueue  ( me  ) ;
}
