// Lisp2D Eval History inside StackCluster
// ©2012-23 by Alex Glebe

# ifndef  LISP2D_STCLHISTORY_H
# define  LISP2D_STCLHISTORY_H
# include "stclhistoryp.h"

# define StackClusterHistoryConstructor Lisp2DStackClusterHistoryConstructor
void  StackClusterHistoryConstructor  ( Lisp2D_tStackClusterHistory * , size_t  memsize ) ;
# define  StackClusterHistoryConstructorDefault Lisp2DStackClusterHistoryConstructorDefault
void  StackClusterHistoryConstructorDefault ( Lisp2D_tStackClusterHistory * ) ;
void  Lisp2DStackClusterHistoryDestructor ( Lisp2D_tStackClusterHistory * ) ;

// ! to pass Exception
void  Lisp2DStackClusterHistoryPush  ( Lisp2D_tStackClusterHistory * , struct Lisp2DStackClusterHistoryStep * ) ;

# define  StackClusterHistorySize Lisp2DStackClusterHistorySize
inline  size_t  StackClusterHistorySize ( Lisp2D_tStackClusterHistory const * me ) ;
# define  StackClusterHistoryIsFull Lisp2DStackClusterHistoryIsFull
inline  bool  StackClusterHistoryIsFull  ( Lisp2D_tStackClusterHistory const * me ) ;
# define  StackClusterHistoryMemorySize Lisp2DStackClusterHistoryMemorySize
inline  size_t  StackClusterHistoryMemorySize  ( Lisp2D_tStackClusterHistory const * me ) ;
# define  StackClusterHistoryHaveLostData Lisp2DStackClusterHistoryHaveLostData
inline  bool  StackClusterHistoryHaveLostData  ( Lisp2D_tStackClusterHistory const * me ) ;
# define  StackClusterHistoryIndexPush  Lisp2DStackClusterHistoryIndexPush
inline  size_t  StackClusterHistoryIndexPush ( Lisp2D_tStackClusterHistory const * const me ) ;
# define  StackClusterHistoryStepAt Lisp2DStackClusterHistoryStepAt
inline  struct  Lisp2DStackClusterHistoryStep  * StackClusterHistoryStepAt  (
  Lisp2D_tStackClusterHistory const * me , size_t  index ) ;
enum  { LISP2DdefaultHistorySize = 12 } ;
# define  StackClusterHistoryGCDeclareContent Lisp2DStackClusterHistoryGCDeclareContent
void  StackClusterHistoryGCDeclareContent ( Lisp2D_tStackClusterHistory const * ) ;
void  Lisp2DStackClusterHistoryClear ( Lisp2D_tStackClusterHistory * ) ;
// after Garbage 
void  Lisp2DStackClusterHistoryInit_ExcStrMem ( Lisp2D_tStackClusterHistory * , size_t newsize ) ;
bool  Lisp2DStackClusterHistoryisBADResize ( Lisp2D_tStackClusterHistory * , size_t newsize ) ;
# define  StackClusterHistoryDeclareForGC Lisp2D_StackClusterHistoryDeclareForGC
void  StackClusterHistoryDeclareForGC ( struct  Lisp2DStackClusterHistoryStep const * ) ;
# endif
