// Lisp2D - String
// ©2006-23 by Alex Glebe
# ifndef  LISP2D_STRING_PRIVATE_H
# define  LISP2D_STRING_PRIVATE_H
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>
# define  PLOString_constrstat  Lisp2D_PLOString_constrstat
extern  _Atomic ( size_t  ) PLOString_constrstat ;

# endif // LISP2D_CONSTRSTAT

# include "string/type.h"

# define  StringPub_cast_StringPri Lisp2D_StringPub_cast_StringPri
inline  PLOStringPri * StringPub_cast_StringPri ( PLOStringPub  * const p ) ;

# define  StringPub_cast_StringPriConst Lisp2D_StringPub_cast_StringPriConst
inline  PLOStringPri const * StringPub_cast_StringPriConst ( PLOStringPub const * const p ) ;

# define  PLOString_Init  Lisp2D_PLOString_Init
void  PLOString_Init ( PLOStringPri * ) ;

# define  PLOString_Destr Lisp2D_PLOString_Destr
void  PLOString_Destr ( PLOStringPri * ) ;

# define  PLOString_InitCopy  Lisp2D_PLOString_InitCopy
void  PLOString_InitCopy ( PLOStringPri * me , PLOStringPub  const * sp ) ;

# define  PLOString_Initwcharstr  Lisp2D_PLOString_Initwcharstr
void  PLOString_Initwcharstr ( PLOStringPri * me , wchar_t volatile const * s ) ;

# define  PLOString_InitMoveString  Lisp2D_PLOString_InitMoveString
void  PLOString_InitMoveString ( PLOStringPri * me , String ( WideChar ) * swc ) ;

# define  PLOString_InitPArray_wchar_c  Lisp2D_PLOString_InitPArray_wchar_c
void  PLOString_InitPArray_wchar_c ( PLOStringPri * me , PArray_wchar_c  s ) ;

# define  PLOString_InitStrBeg  Lisp2D_PLOString_InitStrBeg
void  PLOString_InitStrBeg ( PLOStringPri * me , PLOStringPub  const * vp , size_t indexfirst  ) ;

# define  PLOString_InitStrBegEnd Lisp2D_PLOString_InitStrBegEnd
void  PLOString_InitStrBegEnd ( PLOStringPri * me , PLOStringPub  const * vp , size_t  indexfirst , size_t indexend )  ;

# define  PLOString_InitWChar Lisp2D_PLOString_InitWChar
void  PLOString_InitWChar ( PLOStringPri * , wchar_t ) ;

# endif // LISP2D_STRING_PRIVATE_H
