// Lisp2D interpreter
// ©2020-3 by Alex Glebe

# ifndef  LISP2D_TASKFORTHREAD_H
# define  LISP2D_TASKFORTHREAD_H

# define  TaskForThread_Analyse Lisp2D_TaskForThread_Analyse
# define  TaskForThread_Wait Lisp2D_TaskForThread_Wait
enum eLisp2DTaskForThread { TaskForThread_Analyse , TaskForThread_Wait  } ;

typedef  enum eLisp2DTaskForThread  Lisp2DTaskForThread ;
typedef Lisp2DTaskForThread TaskForThread   ;

# include "stcl/type.h"

typedef TaskForThread  ( Lisp2DFuncBining ) ( StackClusterPrivate * )  ;
typedef Lisp2DFuncBining  FuncBining  ;

typedef FuncBining  * Lisp2DFuncBiningP ;
typedef Lisp2DFuncBiningP FuncBiningP ;

# endif // LISP2D_TASKFORTHREAD_H
