// Thread
// ©2012-23 by Alex Glebe

# include <stdbool.h>
# include <pthread.h>
# include "define.h"
# include "stcl/classc.h"
  
# define  RunningPthArgs  Lisp2DRunningPthArgs
typedef struct  s_RunningPthArgs  RunningPthArgs  ;
// size=72 align=8
struct  s_RunningPthArgs  {
  pthread_cond_t  ready_cond ;
  pthread_cond_t  condrunning2 ;
  pthread_mutex_t ready_mutex ;
  StackClusterPrivate * taskp ;
// ! manager.cpp is very difficult
// !? to dismiss  (use task == nullptr)
  // catching/setting with:  mutexTasks2
// ! init value: false - manager will be wicked
  // ! to make: void Eval() -> enum Eval()
// ! OR                   -> void Eval(RunningPthArgs  * rpt)
// ! to return different value to pthEval2()
// ! if StackCluster in Queue was again twice:
// ! first Thread: make extraThread, extraThread Push(stcl) in Queue
// ! second Thread: stcl processed and make TaskForManagerToQuit or Run or Else
// ! first Thread: MUST to IGNORE stcl.TaskForManager and get NEXT task from the queue
  bool  promise_state ;
  bool  promise_exc ;
  bool  flagWaitSignal  ;
  // ! RunningPthArgs(Exc * &)
# ifdef LISP2D_DEBUG
  bool  debugStartEval  ;
# endif
} ;
  
# define  RunningPthArgsInit  Lisp2D_RunningPthArgsInit
void  RunningPthArgsInit(  RunningPthArgs * );  

# define  RunningPthArgsDestr  Lisp2D_RunningPthArgsDestr
void  RunningPthArgsDestr(  RunningPthArgs * );  

# define  runpthargs  Lisp2Drunpthargs
extern  RunningPthArgs  * runpthargs  ;

# define  pthEval Lisp2DpthEval
void * pthEval  ( void  *  ) ;

# ifdef LISP2D_CONSTRSTAT
    # define  RunningPthArgsconstrstat  Lisp2DRunningPthArgsconstrstat
    extern volatile _Atomic ( size_t  ) RunningPthArgsconstrstat  ;
# define  RunningPthArgsconstrstatValue Lisp2D_RunningPthArgsconstrstatValue
  size_t  RunningPthArgsconstrstatValue ( void  ) ;
# endif
  
// ! [] -> std::array  
# define  pthSystemTask  Lisp2D_pthSystemTask
void * pthSystemTask ( void * ) ;

# include "stcl/inline.h"
