// Thread
// ©2012-23 by Alex Glebe

# include <stdbool.h>
# include <pthread.h>
# include "define.h"

# ifdef LISP2D_CONSTRSTAT

# ifndef  LISP2DEXTERNC
# define  RunningPthreadconstrstat  Lisp2DRunningPthreadconstrstat
extern _Atomic ( size_t  ) RunningPthreadconstrstat  ;
# endif

# endif

# define  RunningPthread  Lisp2DRunningPthread
typedef struct  sLisp2DRunningPthread RunningPthread ;
struct sLisp2DRunningPthread  {
  pthread_t pth ;
} ;

# define  RunningPthreadInit  Lisp2DRunningPthreadInit
void  RunningPthreadInit ( RunningPthread * , void * (  * f ) ( void  *  ) , void  * ) ;
# define  RunningPthreadDestr Lisp2DRunningPthreadDestr
void  RunningPthreadDestr  ( RunningPthread * ) ;
# ifdef LISP2D_CONSTRSTAT
# define  RunningPthreadStat Lisp2DRunningPthreadStat
size_t  RunningPthreadStat  ( void ) ;
# endif

# define  runpthread  Lisp2Drunpthread
extern  RunningPthread  * runpthread  ;

# define  RunningPthreadSetArray  Lisp2DRunningPthreadSetArray
void RunningPthreadSetArray ( RunningPthread  [] ) ;

# define  RunningPthreadArray  Lisp2DRunningPthreadArray
RunningPthread (  * RunningPthreadArray ( void ) ) [ ] ;
