// Lisp2D interpreter
// ©2003-23 by Alex Glebe

# ifndef  LISP2D_UNDEFBOOL_H
# define  LISP2D_UNDEFBOOL_H

// false? + true? => Undef , false & true => Conflict
enum  eLisp2DBoolType {
  Lisp2DBoolUndef , Lisp2DBoolFalse , Lisp2DBoolTrue ,
  Lisp2DBoolConflict
} ;

typedef enum  eLisp2DBoolType Lisp2DBoolType ;
typedef Lisp2DBoolType  BoolType  ;

inline  Lisp2DBoolType Lisp2DBoolNot ( Lisp2DBoolType ) ;

inline  Lisp2DBoolType Lisp2DBoolNot ( Lisp2DBoolType const x ) {
  static  Lisp2DBoolType const arr [ ] = {
    [ Lisp2DBoolUndef ] = Lisp2DBoolUndef ,
    [ Lisp2DBoolFalse ] = Lisp2DBoolTrue ,
    [ Lisp2DBoolTrue  ] = Lisp2DBoolFalse ,
    [ Lisp2DBoolConflict  ] = Lisp2DBoolConflict
  } ;
  return  arr [ x ] ;
}

# endif // LISP2D_UNDEFBOOL_H
