// Lisp2D - Window
// ©2019-23
# ifndef  LISP2D_WINDOW_PUBLIC_H
# define  LISP2D_WINDOW_PUBLIC_H

# ifndef  LISP2D_DONTUSEX11

# define  PLOWindow_plo  Lisp2D_PLOWindow_plo
inline  ParaLispObject * PLOWindow_plo ( PLOWindow * ) ;

# define  PLOWindow_cplo  Lisp2D_PLOWindow_cplo
inline  ParaLispObject const * PLOWindow_cplo ( PLOWindow const * ) ;

# define  PLOWindow_ColorDefaultDepth Lisp2D_PLOWindow_ColorDefaultDepth
inline  int PLOWindow_ColorDefaultDepth ( PLOWindow_pri const * ) ;

# define  ParaLispObjectToPLOWindow Lisp2D_ParaLispObjectToPLOWindow
inline  PLOWindow * ParaLispObjectToPLOWindow ( ParaLispObject * ) ;

# define  ParaLispObjectToPLOWindowConst Lisp2D_ParaLispObjectToPLOWindowConst
inline  PLOWindow const * ParaLispObjectToPLOWindowConst ( ParaLispObject const * ) ;

# define  PLOWindow_staticDestr Lisp2D_PLOWindow_staticDestr
void PLOWindow_staticDestr  ( ParaLispObject * ) ;

# define  PLOWindow_Opened  Lisp2D_PLOWindow_Opened
inline  bool  PLOWindow_Opened  ( PLOWindow const * ) ;

# define  PLOWindow_SetWindowHeight2  Lisp2D_PLOWindow_SetWindowHeight2
// ! to return bool isBAD..
inline  void  PLOWindow_SetWindowHeight2  ( PLOWindow * , unsigned int const h  ) ;

# define  PLOWindow_SetWindowWidth2 Lisp2D_PLOWindow_SetWindowWidth2
// ! to return bool isBAD..
inline  void  PLOWindow_SetWindowWidth2 ( PLOWindow * const me , unsigned int const w ) ;

# define  PLOWindow_Height  Lisp2D_PLOWindow_Height
inline  int PLOWindow_Height  ( PLOWindow const * ) ;

# define  PLOWindow_Width Lisp2D_PLOWindow_Width
inline  int PLOWindow_Width ( PLOWindow const * ) ;

# define  PLOWindow_VectorHeight  Lisp2D_PLOWindow_VectorHeight
inline  size_t  PLOWindow_VectorHeight  ( PLOWindow const * ) ;

# define  PLOWindow_VectorWidth Lisp2D_PLOWindow_VectorWidth
inline  size_t  PLOWindow_VectorWidth ( PLOWindow const * ) ;

# define  Windowp Lisp2D_Windowp
inline  bool  Windowp ( ParaLispObject const * ) ;

# define  PLOWindow_MyDisplay Lisp2D_PLOWindow_MyDisplay
inline  Display *  PLOWindow_MyDisplay ( PLOWindow_pri const * ) ;

# define  PLOWindow_MyWindow  Lisp2D_PLOWindow_MyWindowbhbi
inline  Window  * PLOWindow_MyWindow  ( PLOWindow_pri * ) ;

# define  PLOWindow_MyGC2 Lisp2D_PLOWindow_MyGC2gvef
inline  GC  PLOWindow_MyGC2  ( PLOWindow_pri const * ) ;

# endif // LISP2D_DONTUSEX11
# endif // LISP2D_WINDOW_PUBLIC_H
