// Lisp2D - Stack of ParaLispObject *
// ©2017-23 by Alex Glebe

# include "stack-define.h"
# include "plo/struct.h"
# include "stack-plop.h"

LISP2DSTACKPUSHBYVALUE ( StackPLOP , ParaLispObject * , )
LISP2DSTACKPUSHATVALUE ( StackPLOP , ParaLispObject * )
LISP2D_PROTO_STACK_FREE ( StackPLOP )
LISP2DSTACKPOPVALUE ( StackPLOP , ParaLispObject * )
LISP2DSTACKPOPTOSIZE ( StackPLOP , ParaLispObject * )
# include "sharedc.h"
LISP2DSTACKDESTRUCTOR ( StackPLOP , ParaLispObject * )
LISP2D_STACK_FREE ( StackPLOP , ParaLispObject * )
LISP2DSTACKCLEAR ( StackPLOP , ParaLispObject * )
LISP2DSTACKPOP ( StackPLOP , ParaLispObject * , )
LISP2DSTACKREPLACETOPBYVALUE ( StackPLOP , ParaLispObject * )
LISP2DSTACKBACKCOPY ( StackPLOP , ParaLispObject * )
LISP2DSTACKELTADDR  ( StackPLOP , ParaLispObject * )
LISP2DSTACKFRONTCOPY ( StackPLOP , ParaLispObject * )
LISP2DSTACKELTCOPY ( StackPLOP , ParaLispObject * )
LISP2DSTACKERASEIND  ( StackPLOP , ParaLispObject *  )
LISP2DSTACKCBACK ( StackPLOP , ParaLispObject * )
LISP2DSTACKBACK ( StackPLOP , ParaLispObject * )
LISP2DSTACKRESIZEFILL (  StackPLOP , ParaLispObject * )
LISP2DSTACKRESIZE (  StackPLOP , ParaLispObject * , )
LISP2DSTACKSET (  StackPLOP , ParaLispObject * , )
LISP2DSTACKCEND (  StackPLOP , ParaLispObject * )
LISP2DSTACKEND (  StackPLOP , ParaLispObject * )
LISP2DSTACKSWAP (  StackPLOP , ParaLispObject * )
# include "stack/public.h"
# include "stack/enum.h"

Vector ( StackPLOP ) * StackNew_VectorPLOP ( void  ) {
  return Lisp2D_StackVar ( Lisp2DStackTypeStackPLOP ) ;
}
# include "shared/inline.h"
