// Lisp2D - Stack of ParaLispObject const *
// ©2017-23 by Alex Glebe

# include "stack-define.h"
# include "plo/struct.h"
# include "stack-plopco.h"

LISP2DSTACKPUSHBYVALUE ( StackPLOPC , ParaLispObject const * , )
LISP2DSTACKPUSHATVALUE ( StackPLOPC , ParaLispObject const * )
LISP2D_PROTO_STACK_FREE ( StackPLOPC )
LISP2DSTACKPOPVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKPOPTOSIZE ( StackPLOPC , ParaLispObject const * )
# include "sharedc.h"
LISP2DSTACKDESTRUCTOR ( StackPLOPC , ParaLispObject const * )
LISP2D_STACK_FREE ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKCLEAR ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKPOP ( StackPLOPC , ParaLispObject const * , )
LISP2DSTACKREPLACETOPBYVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKBACKCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKELTADDR  ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKFRONTCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKELTCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKERASEIND  ( StackPLOPC , ParaLispObject const *  )
LISP2DSTACKCBACK ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKBACK ( StackPLOPC , ParaLispObject const * )
LISP2DSTACKRESIZEFILL (  StackPLOPC , ParaLispObject const * )
LISP2DSTACKRESIZE (  StackPLOPC , ParaLispObject const * , )
LISP2DSTACKSET (  StackPLOPC , ParaLispObject const * , )
LISP2DSTACKCEND (  StackPLOPC , ParaLispObject const * )
LISP2DSTACKEND (  StackPLOPC , ParaLispObject const * )
LISP2DSTACKSWAP (  StackPLOPC , ParaLispObject const * )
# include "stack/public.h"
# include "stack/enum.h"

Vector ( StackPLOPC ) * StackNew_VectorPLOPC ( void  ) {
  return Lisp2D_StackVar ( StackType ( StackPLOPC ) ) ;
}
# include "shared/inline.h"
