// Lisp2D interpreter - Unix private area
// ©2015-23 by Alex Glebe

# include <termios.h>  // unix: struct termios
# include <errno.h>
# include <iso646.h>
# include "unix.h"

volatile  bool  Lisp2DflagTTY = true ;

struct  termios Lisp2Dorig_term ;

// the same
void  Lisp2DcheckTerminal ( void ) {
  Lisp2DflagTTY = not tcgetattr ( 0 , & Lisp2Dorig_term ) ; 
}
  
// returns 0 or errno  
int repareTerminal ( void ) {
  if  ( Lisp2DflagTTY ) {
    if  ( tcsetattr ( 0 , TCSAFLUSH , & Lisp2Dorig_term ) )
      return  errno ; 
  }
  return  0 ;
}
