// BackQuote `
// ©2011-23 by Alex Glebe

# include "backquote/type.h"
# include "backquote/public.h"

inline  PLOBackQuote * ParaLispObjectToPLOBackQuote ( ParaLispObject * const p ) {
  return p  ->  vaddr . addr . p ;
}

inline  PLOBackQuote const * ParaLispObjectToPLOBackQuoteConst ( ParaLispObject const * const p ) {
  return p  ->  vaddr . addr . p ;
}

# include "backquote/struct.h"

inline  void  PLOBackQuote_Set ( PLOBackQuote * const me , PLOBackQuote  const * const xp ) {
  me -> item = xp -> item ;
}
    
inline  void  PLOBackQuote_SetItem ( PLOBackQuote * const me , ParaLispObject  * const xp ) {
  me -> item = xp ;
}
    
inline  ParaLispObject  * PLOBackQuote_Item  ( PLOBackQuote const * const me ) {
  return  me -> item ;
}
    
inline  bool  BackQuoteP ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberBackQuotePrivate  ;
}
