// BackQuote `
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_BACKQUOTE_PUBLIC_H
# define  LISP2D_BACKQUOTE_PUBLIC_H

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

# define  PLOBackQuote_constrstat_Inc  Lisp2D_BackQuote_constrstat_Inc
void  PLOBackQuote_constrstat_Inc  ( void  ) ;
# define  PLOBackQuote_constrstat_Value  Lisp2D_BackQuote_constrstat_Value
size_t  PLOBackQuote_constrstat_Value  ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "backquote/type.h"

# define  PLOBackQuote_Init Lisp2D_PLOBackQuote_Init
void  PLOBackQuote_Init ( PLOBackQuote * ) ;

# define  PLOBackQuote_Destr  Lisp2D_PLOBackQuote_Destr
void  PLOBackQuote_Destr ( PLOBackQuote * ) ;

# include "plo/struct.h"
# include "plo/type.h"

# define  PLOBackQuote_staticTypeOf Lisp2D_PLOBackQuote_staticTypeOf
ParaLispObject  * PLOBackQuote_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOBackQuote_staticClassDef Lisp2D_PLOBackQuote_staticClassDef
ParaLispObject  * PLOBackQuote_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOBackQuote_staticClassParents Lisp2D_PLOBackQuote_staticClassParents
ParaLispObject  * PLOBackQuote_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOBackQuote_staticGCDeclareContent Lisp2D_PLOBackQuote_staticGCDeclareContent
void  PLOBackQuote_staticGCDeclareContent ( ParaLispObject *  ) ;  

# define  PLOBackQuote_staticisBADCopyPrivate Lisp2D_PLOBackQuote_staticisBADCopyPrivate
bool  PLOBackQuote_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOBackQuote_staticCoutToHuman  Lisp2D_PLOBackQuote_staticCoutToHuman
void  PLOBackQuote_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;

# define  PLOBackQuote_staticCoutToInterpret  Lisp2D_PLOBackQuote_staticCoutToInterpret
void  PLOBackQuote_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector ( StackPLOP )  *  h ) ;

# include "stcl/classc.h"
  
# define  IsNotBackQuote  Lisp2D_IsNotBackQuote
bool  IsNotBackQuote  ( StackClusterPrivate *  , ParaLispObject  * ) ;

FuncBining  Lisp2Dbimbackquotebackquote2  ;
  FuncBining  Lisp2Dbimnilbackquotep2 ;
  FuncBining  Lisp2Dbimbackquotesetf2 ;
  FuncBining  Lisp2Dbimbackquoteswap2 ;

# define  ParaLispObjectToPLOBackQuote  Lisp2DParaLispObjectToPLOBackQuote
inline  PLOBackQuote * ParaLispObjectToPLOBackQuote ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOBackQuoteConst Lisp2DParaLispObjectToPLOBackQuoteConst
inline  PLOBackQuote const * ParaLispObjectToPLOBackQuoteConst ( ParaLispObject const * ) ;
# define  PLOBackQuote_staticDestr  Lisp2D_PLOBackQuote_staticDestr
void PLOBackQuote_staticDestr  ( ParaLispObject * ) ;
# define  PLOBackQuote_Swap Lisp2D_PLOBackQuote_Swap
void  PLOBackQuote_Swap  ( PLOBackQuote * , PLOBackQuote * ) ;
# define  PLOBackQuote_Set  Lisp2D_PLOBackQuote_Set
inline  void  PLOBackQuote_Set ( PLOBackQuote * , PLOBackQuote  const * ) ;

# define  PLOBackQuote_SetItem  Lisp2D_PLOBackQuote_SetItem
inline  void  PLOBackQuote_SetItem ( PLOBackQuote * , ParaLispObject  * ) ;
# define  PLOBackQuote_Item Lisp2D_PLOBackQuote_Item
inline  ParaLispObject  * PLOBackQuote_Item  ( PLOBackQuote const * ) ;
# define  BackQuoteP  Lisp2D_BackQuoteP
inline  bool  BackQuoteP ( ParaLispObject const * ) ;

# include "stcl/inline.h"

# endif // LISP2D_BACKQUOTE_PUBLIC_H
