// Lisp2D ©2020-3 Glebe A.N.
// type cast protected body's

# ifndef  LISP2D_CASTB_H
# define  LISP2D_CASTB_H

# include "cast.h"

inline  uint16_t  uint8_cast_uint16 ( uint8_t const u ) {
  return  ( uint16_t  ) u ;
}

inline  unsigned int  uint8_cast_uint ( uint8_t const u ) {
  return  ( unsigned int  ) u ;
}

inline  uint8_t  uint16_cast_uint8 ( uint16_t const u ) {
  return  ( uint8_t  ) u ;
}

inline  uint8_t  int_cast_uint8 ( int const i ) {
  return  ( uint8_t  ) i ;
}

inline  uint8_t  uint_cast_uint8 ( unsigned  int const u ) {
  return  ( uint8_t  ) u ;
}

inline  uint16_t  int_cast_uint16 ( int const i ) {
  return  ( uint16_t  ) i ;
}

inline  uint16_t  uint_cast_uint16 ( unsigned int const u ) {
  return  ( uint16_t  ) u ;
}

inline  size_t  int_cast_size ( int const i ) {
  return  ( size_t ) i ;
}

inline  size_t  uint_cast_size ( unsigned  int const u ) {
  return  ( size_t ) u ;
}

inline  unsigned  int int_cast_uint ( int const i ) {
  return  ( unsigned  int ) i ;
}

inline  uint8_t  char_cast_uint8 ( char const c ) {
  return  ( uint8_t  ) c ;
}

inline  char  uint8_cast_char ( uint8_t const u ) {
  return  ( char ) u ;
}

inline  char  uint16_cast_char ( uint16_t const u ) {
  return  ( char ) u ;
}

inline  char  int_cast_char ( int const i ) {
  return  ( char ) i ;
}

inline  char * charvolatilep_cast_charp ( char volatile * const cv ) {
  return  ( char * ) cv ;
}

inline  uint8_t * uint8volatilep_cast_unt8p ( uint8_t volatile * const bv ) {
  return  ( uint8_t * ) bv ;
}

inline  unsigned  long  int lint_cast_ulint ( long  int const li  ) {
  return  ( unsigned  long  int ) li ;
}

inline  unsigned int ulint_cast_uint ( unsigned long  int const uli  ) {
  return  ( unsigned  int ) uli ;
}

inline  unsigned int ullint_cast_uint ( unsigned long  long  int const ulli  ) {
  return  ( unsigned  int ) ulli ;
}

inline  long int ulint_cast_lint ( unsigned long  int const uli  ) {
  return  ( long  int ) uli ;
}

inline  uint8_t wchar_cast_byte ( wchar_t const w ) {
  return  ( uint8_t ) w ;
}

inline  unsigned int wchar_cast_uint ( wchar_t const w ) {
  return  ( unsigned int ) w ;
}

inline  wint_t wchar_cast_wint ( wchar_t const w ) {
  return  ( wint_t ) w ;
}

inline  wchar_t wint_cast_wchar ( wint_t const i ) {
  return  ( wchar_t ) i ;
}

inline  unsigned int const *  voidcp_cast_uintcp ( void const * const v ) {
  return ( unsigned int const * ) v ;
}

inline  unsigned int *  voidp_cast_uintp ( void * const v ) {
  return ( unsigned int * ) v ;
}

inline  uint8_t * voidp_cast_bytep ( void  * const p ) {
  return  ( uint8_t * ) p ;
}

inline  uint8_t const * const_voidp_cast_bytep ( void  const  * const p ) {
  return  ( uint8_t const * ) p ;
}

inline  unsigned  int size_cast_uint  ( size_t  const s ) {
  return  ( unsigned int ) s ;
}

inline  int size_cast_int  ( size_t  const s ) {
  return  ( int ) s ;
}

inline  unsigned int ldouble_cast_uint ( long double const d ) {
  return  ( unsigned int  ) d ;
}

inline  int ldouble_cast_int ( long double const d ) {
  return  ( int  ) d ;
}

inline  unsigned char uint_cast_uchar ( unsigned  int const u ) {
  return  ( unsigned char ) u ;
}

inline  unsigned short int  uint_cast_ushort  ( unsigned  int const u ) {
  return  ( unsigned short int ) u ;
}

inline  unsigned  int uint64_cast_uint ( uint64_t const u ) {
  return  ( unsigned  int ) u ;
}

inline  size_t  ssize_cast_size ( ssize_t const s ) {
  return  ( size_t  ) s ;
}

inline  ssize_t  size_cast_ssize ( size_t const s ) {
  return  ( ssize_t  ) s ;
}

inline int uint_cast_int ( unsigned int const ui ) {
  return  ( int ) ui ;
}

inline  size_t  longint_cast_size_t ( long  int const l ) {
  return  ( size_t  ) l ;
}

inline  wchar_t uint_cast_wchar  ( unsigned int const u ) {
  return  ( wchar_t ) u ;
}

inline  unsigned  char char_cast_uchar  ( char const c ) {
  return  ( unsigned  char ) c ;
}

inline  unsigned  char const * charcp_cast_ucharcp  ( char const * const s ) {
  return  ( unsigned  char const * ) s ;
}

inline  signed  char char_cast_schar  ( char const c ) {
  return  ( signed  char ) c ;
}

inline  unsigned  int uchar_cast_uint  ( unsigned char const u ) {
  return  ( unsigned  int ) u ;
}

inline  wchar_t int_cast_wchar  ( int const i ) {
  return  ( wchar_t ) i ;
}

inline  long  int sizet_cast_longint  ( size_t  const s ) {
  return  ( long int ) s ;
}

inline  long  int uint_cast_longint  ( unsigned int  const u ) {
  return  ( long int ) u ;
}

inline  unsigned  long  int uint_cast_ulint ( unsigned  int const u ) {
  return  ( unsigned  long  int ) u ;
}

inline  unsigned  int longint_cast_uint  ( long int  const li ) {
  return  ( unsigned int ) li ;
}

inline  ptrdiff_t size_cast_ptrdiff ( size_t const s ) {
  return  ( ptrdiff_t ) s ;
}

inline  unsigned  int ptrdiff_cast_uint ( ptrdiff_t const d ) {
  return  ( unsigned  int ) d ;
}

inline  long  double size_cast_longdouble  ( size_t  const s ) {
  return  ( long double ) s ;
}

inline  wchar_t ulint_cast_wchar ( unsigned long int const uli ) {
  return ( wchar_t ) uli ;
}

inline  wchar_t lint_cast_wchar ( long int const li ) {
  return ( wchar_t ) li ;
}

inline  wchar_t const ( *  wcharp_cast_wcharap ( wchar_t const * const x ) ) [ ] {
  return  ( wchar_t const ( * ) [ ] ) ( x ) ;
}

inline  wchar_t const * wcharap_cast_wcharp ( wchar_t const ( * const x ) [ ] ) {
  return  & ( ( * x ) [ 0 ] ) ;
}

inline  long  double   uint8_cast_longdouble  ( uint8_t const b ) {
  return  ( long  double ) b ;
}

inline  long  double   uchar_cast_ldouble  ( unsigned char const uc ) {
  return  ( long  double ) uc ;
}

inline  uint8_t   longdouble_cast_uint8  ( long  double const d ) {
  return  ( uint8_t ) d ;
}

inline  unsigned char ldouble_cast_uchar ( long  double const ld ) {
  return  ( unsigned char ) ld ;
}

inline  long double slong_cast_ldouble ( long int const t ) {
  return  ( long double ) t ;
}

inline  uint8_t int_cast_byte ( int const i ) {
  return  ( uint8_t ) i ;
}

inline  wchar_t * voidp_cast_wcharp ( void  * const p ) {
  return  ( wchar_t * ) p ;
}

inline  wchar_t const * const_voidp_cast_wcharp ( void  const * const p ) {
  return  ( wchar_t const * ) p ;
}

inline  char  wchar_cast_char ( wchar_t const w ) {
  return  ( char ) w ;
}

inline  char  uint_cast_char ( unsigned int const ui ) {
  return  ( char ) ui ;
}

inline  wchar_t const * wcharconstvolatp_cast_wcharconstp ( wchar_t volatile const * const p ) {
  return ( wchar_t const * ) p ;
}

inline  void  *  voidvolatp_cast_voidp ( void volatile * const p ) {
  return  ( void  * ) p ;
}

inline  size_t ldouble_cast_size  ( long double const ld ) {
  return ( size_t ) ld ;
}

# endif // LISP2D_CASTB_H
