// Lisp2D - Character special name
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_CHAR_H
# define  LISP2D_CHAR_H

# include "map.h"
    
LISP2DMAPPUB  ( SetCharValueName  )
extern  MapPub  ( SetCharValueName  ) * const mapPubCharValueName ;
LISP2DMAPCOMPTYPE ( SetCharValueName  , wchar_t )
LISP2DMAPNODETYPE ( SetCharValueName  )
LISP2DMAPNODE (  SetCharValueName  , wchar_t , wchar_t const * )
LISP2DMAPSTACKTYPE  ( SetCharValueName )
LISP2DMAPSTACK (  SetCharValueName )
LISP2DMAPPRI  (  SetCharValueName , wchar_t )
inline  LISP2DPRIFROMMAPPUBPROTO ( SetCharValueName  )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( SetCharValueName  )
inline  LISP2DDECLAREMAPSTACKINIT (  SetCharValueName )
inline  LISP2DMAPPUBINITDECLARE (  SetCharValueName )
LISP2DMAPPUBINSERTPROTO(  SetCharValueName  )
LISP2DPROTOMAPSTACKDESTR (  SetCharValueName )
inline  LISP2DMAPPUBDESTRPROTO (  SetCharValueName )
inline  LISP2DMAPPUBSIZEDECL ( SetCharValueName )
LISP2DMAPPUBFINDPROTO( SetCharValueName , wchar_t volatile )
LISP2DMAPSTACKCATPROTO( SetCharValueName )
inline  LISP2DMAPPUBCATDECL ( SetCharValueName )
LISP2DMAPSTACKPUSHBYVALUEPROTO  ( SetCharValueName )
LISP2PROTODMAPSTACKPUSHFRONTVALUE ( SetCharValueName )
LISP2DMAPSTACKATPROTO( SetCharValueName )
LISP2DMAPSTACKPUSHATVALUEPROTO( SetCharValueName )

LISP2DMAPPUB  ( SetCharNameValue )
extern  MapPub  ( SetCharNameValue  ) * const mapPubCharNameValue ;
LISP2DMAPNODETYPE ( SetCharNameValue  )
LISP2DMAPNODE (  SetCharNameValue  , wchar_t const * , wchar_t )
LISP2DMAPSTACKTYPE  ( SetCharNameValue )
LISP2DMAPSTACK (  SetCharNameValue )
LISP2DMAPPRI  ( SetCharNameValue , wchar_t volatile const * )
LISP2DMAPCOMPTYPE(  SetCharNameValue , wchar_t volatile const * )
inline  LISP2DPRIFROMMAPPUBPROTO ( SetCharNameValue )
inline  LISP2DDECLAREMAPSTACKINIT (  SetCharNameValue )
inline  LISP2DMAPPUBINITDECLARE (  SetCharNameValue )
LISP2DMAPPUBINSERTPROTO(  SetCharNameValue  )
LISP2DPROTOMAPSTACKDESTR (  SetCharNameValue )
inline  LISP2DMAPPUBDESTRPROTO (  SetCharNameValue )
inline  LISP2DCONSTPRIFROMMAPPUBPROTO ( SetCharNameValue )
inline  LISP2DMAPPUBSIZEDECL ( SetCharNameValue )
LISP2DMAPPUBFINDPROTO( SetCharNameValue , wchar_t volatile const * )
LISP2DMAPSTACKCATPROTO( SetCharNameValue )
inline  LISP2DMAPPUBCATDECL ( SetCharNameValue )
LISP2DMAPSTACKPUSHBYVALUEPROTO  ( SetCharNameValue )
LISP2DMAPSTACKPUSHFRONTVALUEPROTO( SetCharNameValue )
LISP2DMAPSTACKATPROTO( SetCharNameValue )
LISP2DMAPSTACKPUSHATVALUEPROTO( SetCharNameValue )

# endif //  LISP2D_CHAR_H
