// Lisp2D - Simple Character String Public
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_CHARSTRING_PUBLIC_H
# define  LISP2D_CHARSTRING_PUBLIC_H

# include "charstring/type.h"
# include "charstring/struct.h"

inline LISP2D_STRING_INIT_DECL ( Char )

LISP2DPROMOSTRINGCONSTRCSTR ( Char , char )
LISP2DPROMOSTRINGCONSTRCSTRMEMSIZE  ( Char , char )

LISP2DPROMOSTRINGDESTR  (Char)

inline  LISP2D_STRING_CSTR_DECL ( Char , char )

inline LISP2D_STRING_CBEGIN_DECL ( Char , char )

LISP2D_STRING_CEND_DECL ( Char  , char  )

LISP2DPROMOSTRINGADDCHAR  ( Char , char )
inline LISP2D_STRING_EMPTY_DECL  ( Char ) // "" = [ \00 ]
inline LISP2D_STRING_SIZE_DECL ( Char )
inline LISP2D_STRING_ELTCOPY_DECL ( Char , char )

LISP2DPROMOSTRINGCLEAR ( Char )

LISP2DPROMOSTRINGSETARRAY( Char , char )

# define  StackNew_StringChar  Lisp2D_StackNew_StringChar
String ( Char ) * StackNew_StringChar ( void  ) ;

inline LISP2DSTRINGINIT ( Char , '\0' )
inline LISP2DSTRINGCSTR ( Char , char )
inline LISP2DSTRINGCBEGIN ( Char , char )
inline LISP2DSTRINGEMPTY  ( Char )
inline LISP2DSTRINGSIZE ( Char )
inline LISP2DSTRINGELTCOPY ( Char , char )

# endif // LISP2D_CHARSTRING_PUBLIC_H
