// Complex Private
// 2023

# ifndef  LISP2D_COMPLEX_PRIVATE_H
# define  LISP2D_COMPLEX_PRIVATE_H

# include "define.h"

# include <stdatomic.h>

# ifdef  LISP2D_CONSTRSTAT
# include <stddef.h> // size_t
# define  Complex_constrstat  Lisp2D_Complex_constrstat
extern  _Atomic  ( size_t  ) Complex_constrstat  ;
# endif

# ifdef  LISP2D_CONSTRSTAT
# define  Complex_constrstat_Inc  Lisp2D_Complex_constrstat_Inc
void  Complex_constrstat_Inc  ( void  ) ;
# endif

# include "complex/type.h"

# define  ComplexPri_Destr Lisp2D_ComplexPri_Destr
void  ComplexPri_Destr ( ComplexPri * ) ;

# include "complex/structpri.h"

# define  Complex_toCPrivate  Lisp2D_Complex_toCPrivate
inline  ComplexPri  const * Complex_toCPrivate  ( Complex const * ) ;
# define  Complex_toPrivate  Lisp2D_Complex_toPrivate
inline  ComplexPri * Complex_toPrivate  ( Complex * ) ;

inline  ComplexPri  const * Complex_toCPrivate  ( Complex const * const p ) {
  return  (ComplexPri  const *)(((uint8_t*)p) - offsetof(ComplexPri,pub));
}

inline  ComplexPri * Complex_toPrivate  ( Complex * const p ) {
  return  (ComplexPri *)(((uint8_t*)p)  - offsetof(ComplexPri,pub));
}

# endif // LISP2D_COMPLEX_PRIVATE_H
