// Lisp2D - Cons iterator - controls list passage
// ©2011-23 by Alex Glebe

# include "consiter/type.h"
# include "plo/type.h"
# include <stdbool.h>

# define  CConsIteratorInit  Lisp2D_CConsIteratorInit
void CConsIteratorInit ( CConsIteratorPub * i , ParaLispObject  * x ) ;

# define  CConsIteratorHaveItem  Lisp2D_CConsIteratorHaveItem
bool  CConsIteratorHaveItem  ( CConsIteratorPub const * ) ;  

# define  CConsIteratorNext  Lisp2D_CConsIteratorNext
void  CConsIteratorNext  ( CConsIteratorPub * ) ;

# define  CConsIteratorItem  Lisp2D_CConsIteratorItem
ParaLispObject  * CConsIteratorItem  ( CConsIteratorPub const * ) ;

# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h> // size_t

# define  ConsIteratorconstrstatValue Lisp2D_ConsIteratorconstrstatValue
size_t  ConsIteratorconstrstatValue ( void  ) ;

# define  ConsIteratorconstrstatInc Lisp2D_ConsIteratorconstrstatInc
void  ConsIteratorconstrstatInc ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# define  NewStackCConsIterator  Lisp2D_NewStackCConsIterator
CConsIteratorPub * NewStackCConsIterator (  void  ) ;

# define  CConsIteratorToPub Lisp2D_CConsIteratorToPub
inline  CConsIteratorPub * CConsIteratorToPub ( CConsIterator * ) ;
# define  CConsIteratorToCPub Lisp2D_CConsIteratorToCPub
inline  CConsIteratorPub const  * CConsIteratorToCPub ( CConsIterator const * ) ;

# include "consiter/struct.h"

inline  CConsIteratorPub * CConsIteratorToPub ( CConsIterator * const pr )  {
  return  & pr  ->  pub ;
}

inline  CConsIteratorPub const  * CConsIteratorToCPub ( CConsIterator const * const pr )  {
  return  & pr  ->  pub ;
}
