// Lisp2D - Deque struct
// ©2023 by Alex Glebe

# ifndef  LISP2D_DEQUE_STRUCT_H
# define  LISP2D_DEQUE_STRUCT_H

# include <stddef.h>
# include "deque/type.h"

struct  Lisp2D_sDequeVoid {
  /* array of pointer's to array of T */ 
  void  * * map ;
  /* count of pointers */ 
  size_t  mapsize  ;
  /* inside first map [ 0 ] */ 
  unsigned  int indexfirst ;
  /* inside last map [ size - 1 ] */ 
  unsigned  int indexlast ;
} ;

struct  sDequeVoidIterator {
  /* & map [ i ] - array of pointer's to array of T */ 
  void  * const * line ;
  /* inside map [ i ] [ index ] */ 
  unsigned  int index ;
} ;

struct  sDequeVoidConstIterator {
  DequeVoidIterator base ;
} ;

struct  sDequeVoidReverseIterator {
  DequeVoidIterator base  ;
} ;

struct  sDequeVoidConstReverseIterator {
  DequeVoidIterator base ;
} ;
  
# endif // LISP2D_DEQUE_STRUCT_H
