// Lisp2D - GlobalListAtomic Public
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_GLOBALLISTA_PUBLIC_H
# define  LISP2D_GLOBALLISTA_PUBLIC_H

# include "globallista/type.h"

# define  GlobalListAtomicConstrStatic  Lisp2DGlobalListAtomicConstrStatic
void  GlobalListAtomicConstrStatic  ( GlobalListAtomic  * ) ;

# include <stddef.h> // size_t

# define  GlobalListAtomicSizeStatic  Lisp2DGlobalListAtomicSizeStatic
size_t  GlobalListAtomicSizeStatic  ( GlobalListAtomic const * ) ;

# include <stdbool.h>

# define  GlobalListAtomicEmptyStatic Lisp2DGlobalListAtomicEmptyStatic
bool  GlobalListAtomicEmptyStatic ( GlobalListAtomic const * ) ;

# include "globallistm/type.h"

# define  GlobalListAtomicFirstStatic Lisp2DGlobalListAtomicFirstStatic
GlobalListMember * GlobalListAtomicFirstStatic ( GlobalListAtomic const * ) ;

# define  GlobalListAtomicPopNotLock  Lisp2DGlobalListAtomicPopNotLock
void  GlobalListAtomicPopNotLock  ( GlobalListAtomic * , GlobalListMember * )  ;

# define  GlobalListAtomicPushNotLock Lisp2DGlobalListAtomicPushNotLock
void  GlobalListAtomicPushNotLock ( GlobalListAtomic  * , GlobalListMember * ) ;

// !? first may be ok but size=0 OR first = NULL but size =1 !?
# define  GlobalListAtomicPushLockNoFreeze Lisp2DGlobalListAtomicPushLockNoFreeze
void  GlobalListAtomicPushLockNoFreeze  ( GlobalListAtomic  * , GlobalListMember  * ) ;

// replace list member position ..,a,..,b,.. -> ..,b,..,a,..
# define  GlobalListAtomicconstrstatValue Lisp2DGlobalListAtomicconstrstatValue
size_t  GlobalListAtomicconstrstatValue ( void  ) ;

# define  GlobalListOfStackClusters2  Lisp2DGlobalListOfStackClusters2
extern  GlobalListAtomic  GlobalListOfStackClusters2 ;

# define  GlobalListAtomicConstr  Lisp2DGlobalListAtomicConstr
void  GlobalListAtomicConstr  ( GlobalListAtomic  * ) ;
# define  GlobalListAtomicSize  Lisp2DGlobalListAtomicSize
size_t  GlobalListAtomicSize  ( GlobalListAtomic const * ) ;

# define  GlobalListAtomicEmpty Lisp2DGlobalListAtomicEmpty
bool  GlobalListAtomicEmpty ( GlobalListAtomic const * ) ;
# define  GlobalListAtomicFirst Lisp2DGlobalListAtomicFirst
// may be nullptr
GlobalListMember * GlobalListAtomicFirst ( GlobalListAtomic const * ) ;

# endif
