// Lisp2D GlobalListMember Struct
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_GLOBALLISTM_STRUCT_H
# define  LISP2D_GLOBALLISTM_STRUCT_H

# include "virttype/type.h"
# include "virttype/struct.h"

// Father class for all
struct  Lisp2DsGlobalListMember {
  // ! to rename to priv_prev
  GlobalListMember  * prev ; // may be nullptr
  // ! to rename to priv_next
  GlobalListMember  * next ; // may be nullptr
  // ? public or private
  VirtualTypePointer vaddr ; // point to struct with GlobalListMember field
} ;

# endif // LISP2D_GLOBALLISTM_STRUCT_H
