// Lisp2D - List of ParaLispObject public declare
// ©2022-3 by Alex Glebe

# ifndef  LISP2D_LISTPLO_PUBLIC_H
# define  LISP2D_LISTPLO_PUBLIC_H

# include "listplo/type.h"
# include "list/public.h"
# include "plo/type.h"

LISP2DLISTINITDECL  ( PLO )
LISP2DLISTDESTRDECL ( PLO )
LISP2DLISTPUSHBACKDECL  ( PLO , ParaLispObject  * )
LISP2DLISTNODEINITDECL  ( PLO , ParaLispObject  * )

# include "listplo/structpri.h"
# include "listplo/inlinepri.h"

inline  LISP2DLISTFIRSTDECL ( PLO )
inline  LISP2DLISTNODENEXTDECL ( PLO )
inline  LISP2DLISTNODEVALUEDECL ( PLO , ParaLispObject  * )

inline  LISP2DLISTFIRSTBODY ( PLO )
inline  LISP2DLISTNODENEXTBODY ( PLO )
inline  LISP2DLISTNODEVALUEBODY ( PLO , ParaLispObject  * )

# endif //  LISP2D_LISTPLO_PUBLIC_H
