// Lisp2D - Mutex auto init/destroy with statistics private struct
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_MUTEX2_STRUCT_H
# define  LISP2D_MUTEX2_STRUCT_H

# include <pthread.h>
# include "object-state.h"
# include "define.h"
# include <stddef.h> // size_t
// Lock -> try{++fast}else lock{++wait} -> transparent = fast/(fast+wait)%

struct  sLisp2DMutex2 {
  pthread_mutex_t m ;
  Lisp2DObjectState s ; 
# ifdef  LISP2D_BIMSTAT
  size_t  statfast  ;
  _Atomic ( size_t  ) statwait  ;
# endif
} ;

# endif // LISP2D_MUTEX2_STRUCT_H
