// Lisp2D - symbol newobject
// ©2006-23 by Alex Glebe
# ifndef  LISP2D_NEWOBJECT_H
# define  LISP2D_NEWOBJECT_H

# define  bimsymbolnewobject  Lisp2Dbimsymbolnewobject
FuncBining  bimsymbolnewobject ;

# define  sUniversalIsNotType Lisp2D_sUniversalIsNotType
# define  tUniversalIsNotType Lisp2D_tUniversalIsNotType
typedef struct  sUniversalIsNotType tUniversalIsNotType ;

struct  sUniversalIsNotType {
  StackClusterPrivate  * const stclp  ;
  ParaLispObject * const xp ;
  int  const  typetype  ;
  bool  res ;
} ;

# define  UniversalIsNotTypess  Lisp2D_UniversalIsNotTypess
void  UniversalIsNotTypess  ( tUniversalIsNotType * ) ;

# define  IsNotType Lisp2D_IsNotType
# define  Lisp2D_IsNotType(  TN  ) Lisp2D_IsNotType_  ##  TN

# define  IsNotTypeTemplDecl  Lisp2D_IsNotTypeTemplDecl
# define  Lisp2D_IsNotTypeTemplDecl( TN ) \
bool  IsNotType ( TN ) ( StackClusterPrivate  * , ParaLispObject  * ) ;

# define  IsNotTypeTemplBody  Lisp2D_IsNotTypeTemplBody
# define  Lisp2D_IsNotTypeTemplBody( TN  , TY  ) \
bool  IsNotType ( TN ) ( StackClusterPrivate  * const stclp ,  ParaLispObject * const xp ) { \
  tUniversalIsNotType ar  = { \
    . stclp = stclp , \
    . xp  = xp ,  \
    . typetype  = TY , \
    . res = false , \
  } ; \
  UniversalIsNotTypess  ( & ar  ) ; \
  return  ar  . res ; \
}

# endif // LISP2D_NEWOBJECT_H
