// Lisp2D - users objects Inline
// ©2006-23 by Alex Glebe
# include "object/public.h"
# include "object/struct.h"

inline  void  PLOObject_SetClassDef ( PLOObject * const me , ParaLispObject  * const cdp ) {
  me -> pri . classdef = cdp ;
}

# include "nilc.h"

inline  bool  Objectp ( ParaLispObject const * const xp ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOObject ;
}

inline  PLOObject const * ParaLispObjectToPLOObjectConst ( ParaLispObject const * const p ) {
  return (  PLOObject const * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOObject * ParaLispObjectToPLOObject ( ParaLispObject * const p ) {
  return (  PLOObject * ) ( p  ->  vaddr . addr . p ) ;
}
