// Passage public
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_PASSAGE_PUBLIC_H
# define  LISP2D_PASSAGE_PUBLIC_H
# include "passage/type.h"

# define  PassageConstructor Lisp2DPassageConstructor_ExcStr
void  PassageConstructor ( Lisp2DPassagePub * ) ;

# define  PassageDestructor Lisp2DPassageDestructor
void  PassageDestructor ( Lisp2DPassagePub * ) ;

# define  PassagePassIn Lisp2DPassagePassIn_ExcStr
void  PassagePassIn ( Lisp2DPassagePub * ) ;

# define  PassagePassOut  Lisp2DPassagePassOut_ExcStr
void  PassagePassOut  ( Lisp2DPassagePub * ) ;

# define  PassagePassLock Lisp2DPassagePassLock_ExcStr
void  PassagePassLock ( Lisp2DPassagePub * )  ;

# define  PassagePassUnLock Lisp2DPassagePassUnLock_ExcStr
void  PassagePassUnLock ( Lisp2DPassagePub * ) ;

# define  passageGCCPub  Lisp2D_passageGCCPub
extern  Lisp2DPassagePub  * const passageGCCPub ;

# include "passage/private.h"

# define  PassageToPub Lisp2D_PassageToPub
inline  struct  Lisp2DsPassagePub * PassageToPub ( struct  Lisp2DPassagePrivate * ) ;

# define  PassageClear  Lisp2DPassageClear
inline  void  PassageClear ( Lisp2DPassagePub * ) ;

inline  struct  Lisp2DsPassagePub * PassageToPub ( struct  Lisp2DPassagePrivate * const pr ) {
  return  & pr  ->  pub ;
}

inline  void  PassageClear ( Lisp2DPassagePub * const pp ) {
  struct  Lisp2DPassagePrivate * const p = Passage_toPrivate ( pp ) ;
  p -> guests = 0 ;
  p -> flagToShout = false ;
}

# endif //  LISP2D_PASSAGE_PUBLIC_H
