// PLOComplex private
// ©2023 by Alex Glebe

# ifndef  LISP2D_PLOCOMPLEX_PRIVATE_H
# define  LISP2D_PLOCOMPLEX_PRIVATE_H
# include "plocomplex/structpri.h"

# define  PLOComplexPubToPri Lisp2D_PLOComplexPubToPri
inline  PLOComplexPri * PLOComplexPubToPri ( PLOComplex * ) ;
# define  PLOComplexPubToPriConst Lisp2D_PLOComplexPubToPriConst
inline  PLOComplexPri const * PLOComplexPubToPriConst ( PLOComplex const * ) ;

inline  PLOComplexPri * PLOComplexPubToPri ( PLOComplex * const c ) {
  return  ( PLOComplexPri * ) ( ( ( uint8_t * ) c ) - offsetof  ( PLOComplexPri , pub ) ) ;
}

inline  PLOComplexPri const * PLOComplexPubToPriConst ( PLOComplex const * const c ) {
  return  ( PLOComplexPri const * ) ( ( ( uint8_t const * ) c ) - offsetof  ( PLOComplexPri , pub ) ) ;
}

# endif // LISP2D_PLOCOMPLEX_PRIVATE_H
