// Lisp2D - Stream
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_PLOSTREAM_STRUCT_H
# define  LISP2D_PLOSTREAM_STRUCT_H

# include "plo/struct.h"
# include "streamc.h"
# include "plostream/type.h"

struct Lisp2DsPLOStream {
  ParaLispObject  plo ;
  Stream  str ;
} ;

struct  sOpenModes {
  mode_t  modeFD  ;
  int flagsFD ;
  bool  flagread  ;
  bool  flagwrite ;
  bool  flagatend ;
} ;

LISP2DMAPNODE ( FlessOpenModes  , ParaLispObject  * , OpenModefFuncP )
LISP2DMAPSTACK  ( FlessOpenModes  )
LISP2DMAPPUB  ( FlessOpenModes  )
LISP2DMAPPRI  ( FlessOpenModes  , ParaLispObject  * )

LISP2DMAPNODE ( FlessMkdirModes , ParaLispObject  * , MKDirFuncP  )
LISP2DMAPSTACK  ( FlessMkdirModes )
LISP2DMAPPUB  ( FlessMkdirModes )
LISP2DMAPPRI  ( FlessMkdirModes , ParaLispObject  * )

# endif // LISP2D_PLOSTREAM_STRUCT_H 
