// Quote ' public
// ©2011-23 by Alex Glebe

# ifndef  LISP2D_QUOTE_PUBLIC_H
# define  LISP2D_QUOTE_PUBLIC_H
# include "define.h"

# ifdef  LISP2D_CONSTRSTAT

# include <stddef.h>

# define  PLOQuote_constrstat_Inc  Lisp2D_Quote_constrstat_Inc
void  PLOQuote_constrstat_Inc  ( void  ) ;
# define  PLOQuote_constrstat_Value  Lisp2D_Quote_constrstat_Value
size_t  PLOQuote_constrstat_Value  ( void  ) ;

# endif // LISP2D_CONSTRSTAT

# include "quote/type.h"

# define  PLOQuote_Init Lisp2D_PLOQuote_Init
void  PLOQuote_Init( PLOQuote * ) ;

# define  PLOQuote_Destr  Lisp2D_PLOQuote_Destr
void  PLOQuote_Destr ( PLOQuote * ) ;

# include "plo/struct.h"

# define  PLOQuote_staticTypeOf Lisp2D_PLOQuote_staticTypeOf
ParaLispObject  * PLOQuote_staticTypeOf ( ParaLispObject const * ) ;

# define  PLOQuote_staticClassDef Lisp2D_PLOQuote_staticClassDef
ParaLispObject  * PLOQuote_staticClassDef  ( ParaLispObject const * ) ;

# define  PLOQuote_staticClassParents Lisp2D_PLOQuote_staticClassParents
ParaLispObject  * PLOQuote_staticClassParents  ( ParaLispObject const * ) ;

# define  PLOQuote_staticGCDeclareContent Lisp2D_PLOQuote_staticGCDeclareContent
void  PLOQuote_staticGCDeclareContent ( ParaLispObject *  ) ;  

# define  PLOQuote_staticisBADCopyPrivate Lisp2D_PLOQuote_staticisBADCopyPrivate
bool  PLOQuote_staticisBADCopyPrivate ( ParaLispObject const * me , ParaLispObject  * * resultp  ) ;

# include "plostream/type.h"

# define  PLOQuote_staticCoutToHuman  Lisp2D_PLOQuote_staticCoutToHuman
void  PLOQuote_staticCoutToHuman ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector  ( StackPLOP )  *  h ) ;

# define  PLOQuote_staticCoutToInterpret  Lisp2D_PLOQuote_staticCoutToInterpret
void  PLOQuote_staticCoutToInterpret ( ParaLispObject const *  me ,
  PLOStream  const *  s , bool flag2pprinted  , Vector ( StackPLOP )  *  h ) ;

# include "stcl/classc.h"
  
# define  IsNotQuote  Lisp2D_IsNotQuote
bool  IsNotQuote  ( StackClusterPrivate *  , ParaLispObject  * ) ;

FuncBining  Lisp2Dbimquotequote2  ;
  FuncBining  Lisp2Dbimnilquotep2 ;
  FuncBining  Lisp2Dbimquotesetf2 ;
  FuncBining  Lisp2Dbimquoteswap2 ;

# include "quote/type.h"

# define  ParaLispObjectToPLOQuote  Lisp2DParaLispObjectToPLOQuote
inline  PLOQuote * ParaLispObjectToPLOQuote ( ParaLispObject * ) ;
# define  ParaLispObjectToPLOQuoteConst Lisp2DParaLispObjectToPLOQuoteConst
inline  PLOQuote const * ParaLispObjectToPLOQuoteConst ( ParaLispObject const * ) ;
# define  PLOQuote_staticDestr  Lisp2D_PLOQuote_staticDestr
void PLOQuote_staticDestr  ( ParaLispObject * ) ;
# define  PLOQuote_Swap Lisp2D_PLOQuote_Swap
void  PLOQuote_Swap  ( PLOQuote * , PLOQuote * ) ;
# define  PLOQuote_Set  Lisp2D_PLOQuote_Set
inline  void  PLOQuote_Set ( PLOQuote * , PLOQuote  const * ) ;
# define  PLOQuote_PItem  Lisp2D_PLOQuote_PItem
inline  ParaLispObject  * * PLOQuote_PItem ( PLOQuote * ) ;
# define  PLOQuote_SetItem  Lisp2D_PLOQuote_SetItem
inline  void  PLOQuote_SetItem ( PLOQuote * , ParaLispObject  * ) ;
# define  PLOQuote_Item Lisp2D_PLOQuote_Item
inline  ParaLispObject  * PLOQuote_Item  ( PLOQuote const * ) ;
# define  QuoteP  Lisp2D_QuoteP
inline  bool  QuoteP ( ParaLispObject const * ) ;

inline  PLOQuote * ParaLispObjectToPLOQuote ( ParaLispObject * const p ) {
  return (  PLOQuote * ) ( p  ->  vaddr . addr . p ) ;
}

inline  PLOQuote const * ParaLispObjectToPLOQuoteConst ( ParaLispObject const * const p ) {
  return (  PLOQuote const * ) ( p  ->  vaddr . addr . p ) ;
}

# include "quote/struct.h"

inline  void  PLOQuote_Set ( PLOQuote * const me , PLOQuote  const * const xp ) {
  me -> item = xp -> item ;
}

inline  ParaLispObject  * * PLOQuote_PItem ( PLOQuote * const me ) {
  return  & me -> item ;
}

inline  void  PLOQuote_SetItem ( PLOQuote * const me , ParaLispObject  * const xp ) {
  me -> item = xp ;
}

inline  ParaLispObject  * PLOQuote_Item  ( PLOQuote const * const me ) {
  return  me -> item ;
}

inline  bool  QuoteP ( ParaLispObject const * const xp  ) {
  return  ParaLispObject_Type ( xp  ) ==  TypeGlobalListMemberPLOQuote  ;
}

# include "stcl/inline.h"

# endif // LISP2D_QUOTE_PUBLIC_H
