// signed Long public
// (C)2019-23
# ifndef  LISP2D_SLONG_INLINE_H
# define  LISP2D_SLONG_INLINE_H

# include "slong/struct.h"
# include "slong/private.h"
# include "slong/public.h"
# include "ulong/inline.h"

// ! to ULongPub
inline void SLongMulULong  ( Lisp2DSLongPub * const my , ULong  const * const x ) {
  Lisp2DSLong * const myp = SLong_toPrivate ( my )  ;
  ULongMultiplyConst ( ULongToPub ( & myp ->  absval  ) , ULongCToPub ( x ) ) ;
} 

// ! to ULongPub
inline ULong const *  SLongCabs  ( Lisp2DSLongPub const * const my ) {
  return & SLong_toCPrivate ( my ) -> absval ;
}

// ! to ULongPub
inline ULong * SLongabs  ( Lisp2DSLongPub * const my ) {
  return & SLong_toPrivate  ( my  ) -> absval ;
}

inline bool  SLongFlagNegative  ( Lisp2DSLongPub const * const my ) {
  return SLong_toCPrivate ( my ) -> flagNegative  ;
}

inline  Lisp2DSLongPub * SLongToPub ( Lisp2DSLong * const pr )  {
  return  & pr  ->  pub ;
}

inline  Lisp2DSLongPub const * SLongCToPub ( Lisp2DSLong const * const pr )  {
  return  & pr  ->  pub ;
}

# endif // LISP2D_SLONG_INLINE_H
