// signed Long public
// (C)2019-23
# ifndef  LISP2D_SLONG_PUBLIC_H
# define  LISP2D_SLONG_PUBLIC_H

# include "define.h"
# include <stddef.h>  //  size_t

# ifdef  LISP2D_CONSTRSTAT  
size_t  Lisp2DSLongconstrstatGetValue  ( void ) ;
void  Lisp2DSLongconstrstatAddOne ( void ) ;
# endif

# include "slong/type.h"

// zero
void  Lisp2DSLongInit ( Lisp2DSLongPub * ) ;
void  Lisp2DSLongConstrCopy ( Lisp2DSLongPub * myp , Lisp2DSLongPub  const * xp ) ;
void  Lisp2DSLongConstrUInt ( Lisp2DSLongPub * myp , unsigned int ) ;
# include <stdbool.h>
# include <ulong/private.h>

# define  s_SLongConstrSignULong  Lisp2D_s_SLongConstrSignULong
# define  t_SLongConstrSignULong  Lisp2D_t_SLongConstrSignULong
typedef struct s_SLongConstrSignULong t_SLongConstrSignULong ;

struct s_SLongConstrSignULong {
  SLongPub * const  my ;
  ULong const * const  xp ;
  bool const  fn ;
} ;

# define  SLongConstrSignULong  Lisp2DSLongConstrSignULong
void  SLongConstrSignULong ( t_SLongConstrSignULong ) ;

void Lisp2DSLongDivULong  (  Lisp2DSLongPub * myp , Lisp2DULong  const * x ) ;  // ! x<>0 !
void Lisp2DSLongMulSLong ( Lisp2DSLongPub * myp , Lisp2DSLongPub  const *  x ) ;
void Lisp2DSLongAddSLong  ( Lisp2DSLongPub * myp , Lisp2DSLongPub  const *  x ) ;
void  Lisp2DSLongDec1 ( Lisp2DSLongPub * myp ) ;  
# define  StackNew_SLong  Lisp2D_StackNew_SLong
Lisp2DSLongPub * StackNew_SLong (  void  )  ;
// ! ULong -> public
# define  SLongSetULong Lisp2DSLongSetULong
void  SLongSetULong ( Lisp2DSLongPub * ,  ULong const * xp ) ;
# define  SLongMulULong Lisp2DSLongMulULong
// ! to ULongPub
inline void SLongMulULong  ( Lisp2DSLongPub * my , ULong  const * x ) ;
// ! to ULongPub
# define  SLongCabs Lisp2DSLongCabs
inline ULong const *  SLongCabs  ( Lisp2DSLongPub const * my ) ;
# define  SLongabs  Lisp2DSLongabs
// ! to ULongPub
inline ULong * SLongabs  ( Lisp2DSLongPub * my ) ;
# define  SLongFlagNegative Lisp2DSLongFlagNegative
inline bool  SLongFlagNegative  ( Lisp2DSLongPub const * my ) ;
# define  SLongToPub Lisp2D_SLongToPub
inline  Lisp2DSLongPub * SLongToPub ( Lisp2DSLong * pr ) ;
# define  SLongCToPub Lisp2D_SLongCToPub
inline  Lisp2DSLongPub const * SLongCToPub ( Lisp2DSLong const * pr ) ;

# endif //  LISP2D_SLONG_PUBLIC_H
