// Lisp2D - Stack of characters
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_STACKCHAR_H
# define  LISP2D_STACKCHAR_H

# include "stack-define.h"
LISP2DSTACKSTRUCTTYPE ( Char  )
LISP2DSTACKSTRUCT ( Char , char  )
LISP2D_PROTO_STACK_FREE ( Char )
// ! to proto and push down
inline  LISP2DSTACKPOPVALUE ( Char , char  )
LISP2DPROTOSTACKISEQ ( Char , char  )
LISP2DPROTOSTACKRESIZE ( Char )
LISP2DPROTOSTACKRESIZE1 ( Char )
LISP2DPROTOSTACKCLEAR  ( Char )
LISP2DPROTOSTACKELTCOPY  ( Char , char )
LISP2DPROTOSTACKPUSHFRONTVALUE  ( Char , char )
LISP2DPROTOSTACKPUSHBYVALUE  ( Char , char )
LISP2DPROTOSTACKINSERTFRONT  ( Char , char )
LISP2DPROTOSTACKSET  ( Char , char )
LISP2DPROTOSTACKDESTRUCTOR ( Char )
LISP2DPROTOSTACKSWAP  ( Char , char )
LISP2DPROTOSTACKPOP ( Char )
LISP2DPROTOSTACKBACKCOPY ( Char , char  )
LISP2DPROTOSTACKREMOVEFRONT  ( Char , char  )
LISP2DPROTOSTACKAT  ( Char , char  )  
LISP2DPROTOSTACKATCOPY  ( Char , char  )
LISP2DPROTOSTACKFRONTCOPY  ( Char , char  )
LISP2DPROTOSTACKCEND  ( Char , char  )
LISP2DPROTOSTACKCBACK  ( Char , char  )
LISP2DPROTOSTACKBACK  ( Char , char  )
LISP2DPROTOSTACKCREND  ( Char , char  )
LISP2DPROTOSTACKCRBEGIN  ( Char , char  )
LISP2DPROTOSTACKEND  ( Char , char  )
inline LISP2DSTACKCONSTRUCTORDEFAULT ( Char )
inline LISP2DSTACKCONSTRONE ( Char , char )
LISP2DPROTOSTACKCONSTRUCTORCOPY  ( Char )
LISP2DDECLARESTACKCONSTRUCTORMOVE ( Char , char )
# endif // LISP2D_STACKCHAR_H
