// Lisp2D - Stack of ( ParaLispObject * )
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_STACKPLOP_H
# define  LISP2D_STACKPLOP_H

# include "stack-define.h"
# include "plo/type.h"

LISP2DSTACKSTRUCTTYPE ( StackPLOP )
LISP2DSTACKSTRUCT ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKPUSHBYVALUE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKPUSHATVALUE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKPOPVALUE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKPOPTOSIZE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKDESTRUCTOR ( StackPLOP )
LISP2DPROTOSTACKCLEAR ( StackPLOP )
LISP2DPROTOSTACKPOP ( StackPLOP )
LISP2DPROTOSTACKREPLACETOPBYVALUE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKBACKCOPY ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKCBACK ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKBACK ( StackPLOP , ParaLispObject * )
inline  LISP2DDECLARESTACKCONSTRUCTORDEFAULT ( StackPLOP )
inline  LISP2DDECLARESTACKCONSTRONE ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKELTADDR ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKSWAP ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKFRONTCOPY ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKELTCOPY ( StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKERASEIND  ( StackPLOP , ParaLispObject *  )
LISP2DPROTOSTACKRESIZEFILL  (  StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKRESIZE  (  StackPLOP )
LISP2DPROTOSTACKSET (  StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKCEND (  StackPLOP , ParaLispObject * )
LISP2DPROTOSTACKEND (  StackPLOP , ParaLispObject * )
# define  StackNew_VectorPLOP  Lisp2D_StackNew_VectorPLOP
Vector ( StackPLOP ) * StackNew_VectorPLOP ( void  )  ;

inline  LISP2DSTACKCONSTRUCTORDEFAULT ( StackPLOP )
inline  LISP2DSTACKCONSTRONE  ( StackPLOP , ParaLispObject * )

# endif // LISP2D_STACKPLOP_H
