// Lisp2D - Stack of ( ParaLispObject const * )
// ©2018-23 by Alex Glebe

# ifndef  LISP2D_STACKPLOPC_H
# define  LISP2D_STACKPLOPC_H

# include "stack-define.h"
# include "plo/type.h"

LISP2DSTACKSTRUCTTYPE ( StackPLOPC )
LISP2DSTACKSTRUCT ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKPUSHBYVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKPUSHATVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKPOPVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKPOPTOSIZE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKDESTRUCTOR ( StackPLOPC )
LISP2DPROTOSTACKCLEAR ( StackPLOPC )
LISP2DPROTOSTACKPOP ( StackPLOPC )
LISP2DPROTOSTACKREPLACETOPBYVALUE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKBACKCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKCBACK ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKBACK ( StackPLOPC , ParaLispObject const * )
inline  LISP2DDECLARESTACKCONSTRUCTORDEFAULT ( StackPLOPC )
inline  LISP2DDECLARESTACKCONSTRONE ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKELTADDR ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKSWAP ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKFRONTCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKELTCOPY ( StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKERASEIND  ( StackPLOPC , ParaLispObject const *  )
LISP2DPROTOSTACKRESIZEFILL  (  StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKRESIZE  (  StackPLOPC )
LISP2DPROTOSTACKSET (  StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKCEND (  StackPLOPC , ParaLispObject const * )
LISP2DPROTOSTACKEND (  StackPLOPC , ParaLispObject const * )
# define  StackNew_VectorPLOPC  Lisp2D_StackNew_VectorPLOPC
Vector ( StackPLOPC ) * StackNew_VectorPLOPC ( void  )  ;

inline  LISP2DSTACKCONSTRUCTORDEFAULT ( StackPLOPC )
inline  LISP2DSTACKCONSTRONE  ( StackPLOPC , ParaLispObject const * )

# endif // LISP2D_STACKPLOPC_H
