// Lisp2D - Stack universal types Public
// ©2019-23 by Alex Glebe

# ifndef LISP2D_STACK_PUBLIC_H
# define LISP2D_STACK_PUBLIC_H

# include "stack/type.h"

void * Lisp2D_StackVar ( ThreadStackTypeType ) ;

void  Lisp2D_StackFree  ( ThreadStackPointerType ) ;

# define  StackTypesInit  Lisp2D_StackTypesInit
void  StackTypesInit  ( void  ) ;

inline ThreadStackPointerType Lisp2DThreadSP ( void ) ;

# include "stack/private.h"

inline ThreadStackPointerType Lisp2DThreadSP ( void ) {
  return Lisp2D_thread_stack_sp ;
}

# endif //  LISP2D_STACK_PUBLIC_H
