// StackCluster public
// (C)2023
# ifndef  LISP2D_STCL_PUBLIC_H
# define  LISP2D_STCL_PUBLIC_H

# define  StackClusterPrivate_flagcont  Lisp2D_StackClusterPrivate_flagcont
inline struct  Lisp2DAddrForReturn2  StackClusterPrivate_flagcont  ( StackClusterPrivate const * ) ;

# include "eval-addr/type.h"

# define  FlagCont  Lisp2DFlagCont
inline  EvalAddrCont2 FlagCont ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_myHistory Lisp2D_StackClusterPrivate_myHistory
inline struct  Lisp2DStackClusterHistory * StackClusterPrivate_myHistory ( StackClusterPrivate * ) ;

# define  isBADResizeHistory  Lisp2DisBADResizeHistory
inline bool  isBADResizeHistory  ( StackClusterPrivate  *  , size_t  newsize ) ; // returns error

# define  StackClusterPrivate_myHistoryC  Lisp2D_StackClusterPrivate_myHistoryC
inline struct  Lisp2DStackClusterHistory const * StackClusterPrivate_myHistoryC ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_wanttobeingarbage Lisp2D_StackClusterPrivate_wanttobeingarbage
inline bool  StackClusterPrivate_wanttobeingarbage ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_setwanttobeingarbage  Lisp2D_StackClusterPrivate_setwanttobeingarbage
inline void  StackClusterPrivate_setwanttobeingarbage ( StackClusterPrivate * , bool  g ) ;

# define  StackClusterPrivate_exceptionhistory  Lisp2D_StackClusterPrivate_exceptionhistory
inline ParaLispObject  * StackClusterPrivate_exceptionhistory ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_setexceptionhistory Lisp2D_StackClusterPrivate_setexceptionhistory
inline void  StackClusterPrivate_setexceptionhistory ( StackClusterPrivate * , ParaLispObject  * eh ) ;

# define  StackClusterPrivate_exceptionvalue  Lisp2D_StackClusterPrivate_exceptionvalue
inline ParaLispObject  * StackClusterPrivate_exceptionvalue ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_setexceptionvalue  Lisp2D_StackClusterPrivate_setexceptionvalue
inline void StackClusterPrivate_setexceptionvalue ( StackClusterPrivate * , ParaLispObject  * ev ) ;

# define  StackClusterPrivate_exceptionnotprocessed  Lisp2D_StackClusterPrivate_exceptionnotprocessed
inline bool  StackClusterPrivate_exceptionnotprocessed ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_setexceptionnotprocessed Lisp2D_StackClusterPrivate_setexceptionnotprocessed
inline void  StackClusterPrivate_setexceptionnotprocessed ( StackClusterPrivate * , bool x ) ;

# define  StackClusterPrivate_result Lisp2D_StackClusterPrivate_result
inline ParaLispObject  * StackClusterPrivate_result ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_resultp Lisp2D_StackClusterPrivate_resultp
inline ParaLispObject  * * StackClusterPrivate_resultp ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_setresult Lisp2D_StackClusterPrivate_setresult
inline void  StackClusterPrivate_setresult ( StackClusterPrivate * , ParaLispObject  * v ) ;

# include "env/type.h"

# define  StackClusterPrivate_envLocal  Lisp2D_StackClusterPrivate_envLocal
inline Environment * StackClusterPrivate_envLocal ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_envLocalc  Lisp2D_StackClusterPrivate_envLocalc
inline Environment const * StackClusterPrivate_envLocalc ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_envExternal Lisp2D_StackClusterPrivate_envExternal
inline Environment * StackClusterPrivate_envExternal ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_envExternalc Lisp2D_StackClusterPrivate_envExternalc
inline Environment const * StackClusterPrivate_envExternalc ( StackClusterPrivate const  * ) ;

# define  StackClusterPrivate_whole Lisp2D_StackClusterPrivate_whole
inline ParaLispObject  * StackClusterPrivate_whole ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_wholep  Lisp2D_StackClusterPrivate_wholep
inline ParaLispObject  * * StackClusterPrivate_wholep ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_setwhole  Lisp2D_StackClusterPrivate_setwhole
inline void StackClusterPrivate_setwhole ( StackClusterPrivate * , ParaLispObject  * w ) ;

# define  StackClusterPrivate_flagApplystate  Lisp2D_StackClusterPrivate_flagApplystate
inline bool  StackClusterPrivate_flagApplystate ( StackClusterPrivate const  * ) ;

# define  StackClusterPrivate_setflagApply Lisp2D_StackClusterPrivate_setflagApply
inline void  StackClusterPrivate_setflagApply ( StackClusterPrivate * , bool f ) ;

# define  StackClusterPrivate_flagcontp Lisp2D_StackClusterPrivate_flagcontp
inline struct  Lisp2DAddrForReturn2  * StackClusterPrivate_flagcontp ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_setflagcont Lisp2D_StackClusterPrivate_setflagcont
inline void  StackClusterPrivate_setflagcont ( StackClusterPrivate * , struct  Lisp2DAddrForReturn2  * x ) ;

# define  StackClusterPrivate_setflagcontv  Lisp2D_StackClusterPrivate_setflagcontv
inline void  StackClusterPrivate_setflagcontv ( StackClusterPrivate * , struct  Lisp2DAddrForReturn2  x ) ;

# define  StackClusterPrivate_setTaskForManager Lisp2D_StackClusterPrivate_setTaskForManager
inline void  StackClusterPrivate_setTaskForManager ( StackClusterPrivate * , int f ) ;

# define  StackClusterPrivate_TaskForManager  Lisp2D_StackClusterPrivate_TaskForManager
inline int StackClusterPrivate_TaskForManager ( StackClusterPrivate const  * ) ;

# define  StackClusterPrivate_stackcproArgp Lisp2D_StackClusterPrivate_stackcproArgp
inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcproArgp ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_stackcMethodcp Lisp2D_StackClusterPrivate_stackcMethodcp
inline Vector  ( StackPLOP ) const * StackClusterPrivate_stackcMethodcp  ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_stackcMethodp Lisp2D_StackClusterPrivate_stackcMethodp
inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcMethodp  ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_resultplace Lisp2D_StackClusterPrivate_resultplace
inline ParaLispObject  * * StackClusterPrivate_resultplace ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_setresultplace Lisp2D_StackClusterPrivate_setresultplace
inline void  StackClusterPrivate_setresultplace ( StackClusterPrivate  * , ParaLispObject  * * x ) ;

# define  StackClusterPrivate_setresultplaceforgc Lisp2D_StackClusterPrivate_setresultplaceforgc
inline void  StackClusterPrivate_setresultplaceforgc ( StackClusterPrivate  * , ParaLispObject  * x ) ;

# define  StackClusterPrivate_resultplaceforgc Lisp2D_StackClusterPrivate_resultplaceforgc
inline ParaLispObject  *  StackClusterPrivate_resultplaceforgc ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_stackcp Lisp2D_StackClusterPrivate_stackcp
inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcp ( StackClusterPrivate * ) ;

# include "stack-addrforreturn.h"

# define  StackClusterPrivate_stackAddrp  Lisp2D_StackClusterPrivate_stackAddrp
inline Vector  ( StackAddrForReturn  ) * StackClusterPrivate_stackAddrp ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_stackAddrcp Lisp2D_StackClusterPrivate_stackAddrcp
inline Vector  ( StackAddrForReturn  ) const * StackClusterPrivate_stackAddrcp ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_stackcThisp Lisp2D_StackClusterPrivate_stackcThisp
inline Vector  ( StackPLOP ) * StackClusterPrivate_stackcThisp ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_stackcThiscp  Lisp2D_StackClusterPrivate_stackcThiscp
inline Vector  ( StackPLOP ) const * StackClusterPrivate_stackcThiscp ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_sonscount  Lisp2D_StackClusterPrivate_sonscount
size_t  StackClusterPrivate_sonscount ( StackClusterPrivate const  * ) ;

# define  StackClusterPrivate_sonscountinc  Lisp2D_StackClusterPrivate_sonscountinc
inline void  StackClusterPrivate_sonscountinc ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_sonscountdec  Lisp2D_StackClusterPrivate_sonscountdec
void  StackClusterPrivate_sonscountdec ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_globallistmember Lisp2D_StackClusterPrivate_globallistmember
inline GlobalListMember *  StackClusterPrivate_globallistmember ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_setscFatherp Lisp2D_StackClusterPrivate_setscFatherp
inline void StackClusterPrivate_setscFatherp  ( StackClusterPrivate * s , StackClusterPrivate * f ) ;

# define  StackClusterPrivate_scFatherp  Lisp2D_StackClusterPrivate_scFatherp
inline StackClusterPrivate * StackClusterPrivate_scFatherp  ( StackClusterPrivate const * ) ;

# include "mutexp.h"

# define  StackClusterPrivate_mutexExceptionC Lisp2D_StackClusterPrivate_mutexExceptionC
inline Lisp2DMutex * StackClusterPrivate_mutexExceptionC ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_mutexTask Lisp2D_StackClusterPrivate_mutexTask
inline Lisp2DMutex * StackClusterPrivate_mutexTask ( StackClusterPrivate * ) ;

# include "consatomic/type.h"

# define  StackClusterPrivate_sethandtoqueue  Lisp2D_StackClusterPrivate_sethandtoqueue
inline void  StackClusterPrivate_sethandtoqueue (  StackClusterPrivate * , ConsAtomicPointe * ) ;

# define  StackClusterPrivate_handtoqueuelink Lisp2D_StackClusterPrivate_handtoqueuelink
inline ConsAtomicPointe * * StackClusterPrivate_handtoqueuelink ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_handtoqueue Lisp2D_StackClusterPrivate_handtoqueue
inline ConsAtomicPointe * StackClusterPrivate_handtoqueue ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_Push Lisp2D_StackClusterPrivate_Push
inline void  StackClusterPrivate_Push ( StackClusterPrivate * , ParaLispObject * xp  ) ;

# define  StackClusterPrivate_Pop Lisp2D_StackClusterPrivate_Pop
void  StackClusterPrivate_Pop ( StackClusterPrivate * , ParaLispObject * * resultargp  ) ;

# define  StackClusterPrivate_PopValue  Lisp2D_StackClusterPrivate_PopValue
inline ParaLispObject * StackClusterPrivate_PopValue ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_Popn  Lisp2D_StackClusterPrivate_Popn
inline void  StackClusterPrivate_Popn ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_ThisTop Lisp2D_StackClusterPrivate_ThisTop
inline ParaLispObject  * StackClusterPrivate_ThisTop ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_ArgTop  Lisp2D_StackClusterPrivate_ArgTop
inline ParaLispObject  * StackClusterPrivate_ArgTop  ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_ReplaceArg  Lisp2D_StackClusterPrivate_ReplaceArg
inline void  StackClusterPrivate_ReplaceArg  ( StackClusterPrivate * , ParaLispObject * ap ) ;

# define  StackClusterPrivate_Env Lisp2D_StackClusterPrivate_Env
inline ParaLispObject  * StackClusterPrivate_Env ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_ExtEnv  Lisp2D_StackClusterPrivate_ExtEnv
inline ParaLispObject  * StackClusterPrivate_ExtEnv  ( StackClusterPrivate const * ) ;

# define  StackClusterPrivate_EnvCDR  Lisp2D_StackClusterPrivate_EnvCDR
inline void  StackClusterPrivate_EnvCDR  ( StackClusterPrivate * ) ;

# define  StackClusterPrivate_SetEnv  Lisp2D_StackClusterPrivate_SetEnv
inline void  StackClusterPrivate_SetEnv  ( StackClusterPrivate * , ParaLispObject * ep  ) ;

# define  StackClusterPrivate_SetExtEnv Lisp2D_StackClusterPrivate_SetExtEnv
inline void  StackClusterPrivate_SetExtEnv ( StackClusterPrivate * , ParaLispObject  * ep ) ;

# define  StackClusterPrivate_SetEnv3 Lisp2D_StackClusterPrivate_SetEnv3
inline void  StackClusterPrivate_SetEnv3 ( StackClusterPrivate * , ParaLispObject  * a , ParaLispObject  * c ) ;

# define  StackClusterPrivate_SetResult Lisp2D_StackClusterPrivate_SetResult
inline void  StackClusterPrivate_SetResult ( StackClusterPrivate * , ParaLispObject  * xp ) ;

# endif // LISP2D_STCL_PUBLIC_H
