// Lisp2D Eval History inside StackCluster Inline
// ©2012-23 by Alex Glebe

# ifndef  LISP2D_STCLHISTORY_INLINE_H
# define  LISP2D_STCLHISTORY_INLINE_H
# include "stclhistory.h"
inline  size_t  StackClusterHistorySize ( struct  Lisp2DStackClusterHistory const * const me ) {
  if  ( me -> isFull  )
    return me -> sizeMemory ;
  return me -> indexPush  ;
}
inline  bool  StackClusterHistoryIsFull  ( struct  Lisp2DStackClusterHistory const * const me ) {
  return  me -> isFull  ;
}
inline  size_t  StackClusterHistoryMemorySize  ( struct  Lisp2DStackClusterHistory const * const me ) {
  return  me -> sizeMemory  ;
}
inline  bool  StackClusterHistoryHaveLostData  ( struct  Lisp2DStackClusterHistory const * const me ) {
  return  me -> haveLostData  ;
}
inline  size_t  StackClusterHistoryIndexPush ( struct  Lisp2DStackClusterHistory const * const me ) {
  return  me -> indexPush ;
}
inline  struct  Lisp2DStackClusterHistoryStep  * StackClusterHistoryStepAt  (
  struct  Lisp2DStackClusterHistory const * const me , size_t  index ) {
  return  ( me -> history )  + index ;
}
# endif // LISP2D_STCLHISTORY_INLINE_H
