// Lisp2D - String methods
// ©2011-23 by Alex Glebe

# include "taskforthread.h" // FuncBining

# define  bimstringplus Lisp2D_bimstringplus
FuncBining  bimstringplus ;
# define  bimstringplussetf Lisp2D_bimstringplussetf
FuncBining  bimstringplussetf ;
# define  bimstringequal  Lisp2D_bimstringequal
FuncBining  bimstringequal ;
# define  bimstringnotequal Lisp2D_bimstringnotequal
FuncBining  bimstringnotequal ;
# define  bimstringelt  Lisp2D_bimstringelt
FuncBining  bimstringelt ;
# define  bimstringsetelt Lisp2D_bimstringsetelt
FuncBining  bimstringsetelt ;
# define  bimstringsize Lisp2D_bimstringsize
FuncBining  bimstringsize ;
# define  bimstringread Lisp2D_bimstringread
FuncBining  bimstringread ;
# define  bimstringsymbol Lisp2D_bimstringsymbol
FuncBining  bimstringsymbol ;
# define  bimstringsave Lisp2D_bimstringsave
FuncBining  bimstringsave ;
# define  bimstringgetenv Lisp2D_bimstringgetenv
FuncBining  bimstringgetenv ;
# define  bimstringsetenv Lisp2D_bimstringsetenv
FuncBining  bimstringsetenv ;
# define  bimstringunsetenv Lisp2D_bimstringunsetenv
FuncBining  bimstringunsetenv ;
# define  bimstringrename Lisp2D_bimstringrename
FuncBining  bimstringrename   ;
# define  bimstringless Lisp2D_bimstringless
FuncBining  bimstringless  ;
# define  bimstringmore Lisp2D_bimstringmore
FuncBining  bimstringmore   ;
# define  bimstringlessoreq Lisp2D_bimstringlessoreq
FuncBining  bimstringlessoreq  ;
# define  bimstringmoreoreq Lisp2D_bimstringmoreoreq
FuncBining  bimstringmoreoreq  ;
# define  bimstringmin  Lisp2D_bimstringmin
FuncBining  bimstringmin  ;
# define  bimstringmax  Lisp2D_bimstringmax
FuncBining  bimstringmax  ;
# define  bimstringupper  Lisp2D_bimstringupper
FuncBining  bimstringupper  ;
# define  bimstringlower  Lisp2D_bimstringlower
FuncBining  bimstringlower  ;
# define  bimstringlist Lisp2D_bimstringlist
FuncBining  bimstringlist   ;
# define  bimstringvector Lisp2D_bimstringvector
FuncBining  bimstringvector   ;
# define  bimstringbytevector Lisp2D_bimstringbytevector
FuncBining  bimstringbytevector   ;
# define  bimstringsetf Lisp2D_bimstringsetf
FuncBining  bimstringsetf   ;
# define  bimstringswap Lisp2D_bimstringswap
FuncBining  bimstringswap   ;
# define  bimstringfor  Lisp2D_bimstringfor
FuncBining  bimstringfor  ;
# define  bimstringforcons  Lisp2D_bimstringforcons
FuncBining  bimstringforcons  ;
# define  bimstringload Lisp2D_bimstringload
FuncBining  bimstringload  ;
# define  bimstringstring Lisp2D_bimstringstring
FuncBining  bimstringstring ;
# define  bimstringresize Lisp2D_bimstringresize
FuncBining  bimstringresize ;
# define  bimstringnsubstitute  Lisp2D_bimstringnsubstitute
FuncBining  bimstringnsubstitute  ;  
# define  bimnilstring  Lisp2D_bimnilstring
FuncBining  bimnilstring  ;
# define  bimnilstringp Lisp2D_bimnilstringp
FuncBining  bimnilstringp  ;
# define  bimstringsubseq Lisp2D_bimstringsubseq
FuncBining  bimstringsubseq  ; 

# include "plo/type.h" // ParaLispObject
# include <stdbool.h>

# define  IsNotString Lisp2D_IsNotString
bool  IsNotString ( StackClusterPrivate  * , ParaLispObject * )  ;
# define  IsNotStringLockGC Lisp2D_IsNotStringLockGC
bool  IsNotStringLockGC ( StackClusterPrivate  * , ParaLispObject * ) ;
# define  bimnilman Lisp2D_bimnilman
FuncBining bimnilman ; 
