// (C)2019-23 ULong Inline
# ifndef  LISP2D_ULONG_INLINE_H
# define  LISP2D_ULONG_INLINE_H

# include "ulong/public.h"

inline  ULongPub * voidpcastulongpub ( void * const p ) {
  return  ( ULongPub * ) p ;
}

# include "ulong/struct.h"
# include "ulong/private.h"

inline  void  ULongClear ( ULongPub * const my ) {
  Lisp2DStackUnsIntClear ( & ( ULong_toPrivate (my) ->  valuec ) ) ;
}

inline  void  ULongSet0  ( ULongPub * const me ) {
  Lisp2DStackUnsIntClear ( & (ULong_toPrivate(me)->valuec  ) ) ; 
}

inline  size_t  ULongValueSize ( ULongPub const * const me ) {
  return  VectorSizeCopy  ( StackUnsInt ) ( & ( ULong_toCPrivate  ( me  ) ->  valuec  ) ) ;
}

inline  bool  ULongIs0 ( ULongPub const * const mep ) {
  return  VectorEmpty ( StackUnsInt ) ( & ULong_toCPrivate ( mep ) ->  valuec  ) ;
}

inline Vector ( StackUnsInt ) const * ULongCValue ( ULongPub const * const my ) {
  return & ULong_toCPrivate ( my ) ->  valuec  ; 
}

inline  ULongPub * ULongToPub ( ULong * const p ) {
  return  & p ->  pub ;
}

inline  ULongPub const  * ULongCToPub ( ULong const  * const p ) {
  return  & p ->  pub ;
}
  
inline  bool  ULongMore ( ULongPub  const * const my , ULongPub  const * const x ) {
  return ULongLess ( x , my ) ; 
}

inline  void  ULongSet ( ULongPub * const  my , ULongPub  const * const  x ) {
  VectorSet ( StackUnsInt ) ( & ULong_toPrivate(my) -> valuec , & ( ULong_toCPrivate(x) -> valuec ) ) ;
}

inline  void  ULongMove ( ULongPub * const my , ULongPub * const x ) {
  Vector_Swap ( StackUnsInt ) ( & ULong_toPrivate(my) -> valuec  , & ( ULong_toPrivate(x) -> valuec  ) ) ;
}

inline  void  ULongSwap ( ULongPub * const my , ULongPub * const x ) {
  Vector_Swap ( StackUnsInt ) ( & ULong_toPrivate(my) -> valuec  , & ( ULong_toPrivate(x) -> valuec  ) ) ;
}

# endif // LISP2D_ULONG_INLINE_H
