// (C)2019-23 ULong public
# ifndef  LISP2D_ULONG_PUBLIC_H
# define  LISP2D_ULONG_PUBLIC_H

# include "define.h"
# ifdef  LISP2D_CONSTRSTAT  
# define  ULongconstrstatGetValue Lisp2DULongconstrstatGetValue
size_t  ULongconstrstatGetValue  ( void ) ;
# define  ULongconstrstatAddOne Lisp2DULongconstrstatAddOne
void  ULongconstrstatAddOne ( void ) ;
# endif

// zero
# define  ULong_Init Lisp2D_ULong_Init
void  ULong_Init ( ULongPub * ) ;
# define  ULongDestrPub  Lisp2D_ULongDestrPub
void  ULongDestrPub  ( ULongPub * ) ;
# define  ULongConstrUInt Lisp2DULongConstrUInt
void  ULongConstrUInt ( ULongPub * myp , unsigned int  x ) ;

# define  ULong_ConstrCopy Lisp2DULongConstrCopy_ExcMem
void  ULong_ConstrCopy ( ULongPub * myp , ULongPub  const * xp ) ;

# define  ULongConstrMove Lisp2DULongConstrMove
void  ULongConstrMove ( ULongPub * myp , ULongPub * xp ) ;
// /= (2^pow)   
# define  ULongDiv2Power  Lisp2DULongDiv2Power
void  ULongDiv2Power  ( ULongPub * myp , size_t  pow ) ;
// /= 2
# define  ULongDiv2 Lisp2DULongDiv2
void  ULongDiv2  ( ULongPub * myp ) ;
# define  ULongisEqUInt Lisp2DULongisEqUInt
bool  ULongisEqUInt ( ULongPub const * myp , unsigned  int  x ) ;  
# define  ULongLessUInt Lisp2DULongLessUInt
bool  ULongLessUInt ( ULongPub const * myp , unsigned  int  x ) ;
# define  ULongMoreUInt Lisp2DULongMoreUInt
bool  ULongMoreUInt ( ULongPub const * myp , unsigned  int  x ) ;
# define  ULongMod2 Lisp2DULongMod2
unsigned  int ULongMod2  ( ULongPub const * myp ) ;
# define  ULongEvenP  Lisp2DULongEvenP
bool  ULongEvenP ( ULongPub const * mep ) ;
# define  ULongisEqULong  Lisp2DULongisEqULong
bool  ULongisEqULong ( ULongPub  const * mep , ULongPub  const * xp  )  ;  
# define  ULongIs1  Lisp2DULongIs1
bool  ULongIs1 ( ULongPub  const * mep ) ;
# define  ULongIsBADUIValue Lisp2DULongIsBADUIValue
bool  ULongIsBADUIValue  ( ULongPub  const * mep  , unsigned int * resultp )  ;
# define  ULongisBADByteValue Lisp2DULongisBADByteValue
bool  ULongisBADByteValue  ( ULongPub  const * mep  , uint8_t  * resp  ) ;
// used by : stream write-byte number|byte-vector 
# define  ULongisBADUCharValue  Lisp2DULongisBADUCharValue
bool  ULongisBADUCharValue ( ULongPub  const * mep  ,
  unsigned char  * res  )  ;
# define  ULongisBADUShortValue Lisp2DULongisBADUShortValue
bool  ULongisBADUShortValue ( ULongPub  const * mep  ,
  unsigned short int * resultp  ) ;
# define  ULongIsBADSizeValue Lisp2DULongIsBADSizeValue
bool  ULongIsBADSizeValue  ( ULongPub  const * mep  , size_t * resultp  ) ;  
# define  ULongIsBADUI16Value Lisp2DULongIsBADUI16Value
bool  ULongIsBADUI16Value  ( ULongPub  const * mep  , uint16_t * resultp )  ;  
# define  ULongisOKULValue  Lisp2DULongisOKULValue
bool  ULongisOKULValue ( ULongPub  const * mep  , unsigned long  int * resultp ) ;
# define  ULongSetWChar Lisp2DULongSetWChar
void  ULongSetWChar ( ULongPub * mep , wchar_t  x  )  ;  
# define  ULongSetUSize Lisp2DULongSetUSize
void  ULongSetUSize ( ULongPub * mep  , size_t  x ) ;
# define  ULongSetULInt Lisp2DULongSetULInt
void  ULongSetULInt  ( ULongPub * mep , unsigned long  int x ) ;
# define  ULongSet1 Lisp2DULongSet1
void  ULongSet1 ( ULongPub * mep ) ;
# define  ULongSetFromBits  Lisp2DULongSetFromBits
void  ULongSetFromBits  ( ULongPub * mep , void const * x  , size_t bits ) ;
// me - clear   , swap(me,l)
# define  ULongClearSwap  Lisp2DULongClearSwap
void  ULongClearSwap ( ULongPub  * mep , ULongPub  * lp ) ;  
# define  ULongClearMove  Lisp2D_ULongClearMove
void  ULongClearMove ( ULongPub  * mep , ULongPub  * lp ) ;
# define  ULongAdd1 Lisp2DULongAdd1
void  ULongAdd1 ( ULongPub  * mep  ) ;
# define  ULongSetFromBitsNegativeSize  Lisp2DULongSetFromBitsNegativeSize
void  ULongSetFromBitsNegativeSize  ( ULongPub  * mep , void const * x  , size_t  bits  ) ;
# define  ULongSubUInt  Lisp2DULongSubUInt
void  ULongSubUInt  ( ULongPub  * mep , unsigned int ui ) ;
# define  ULongSetUInt  Lisp2DULongSetUInt
void  ULongSetUInt ( ULongPub * mep ,  unsigned  int x ) ;
// *= 2^bits OR <<= bits
# define  ULongMul2Power  Lisp2DULongMul2Power
void  ULongMul2Power ( ULongPub * mep , size_t  bits )  ;
// this := (this - x)
// may returns BAD if this less x
# define  ULongDifferenceEq Lisp2DULongDifferenceEq
void  ULongDifferenceEq ( ULongPub * mep , ULongPub  const * lp )  ;
# define  ULongAddUInt  Lisp2DULongAddUInt
void  ULongAddUInt  ( ULongPub * mep , unsigned int x ) ;
# define  ULongAddTemp  Lisp2DULongAddTemp
void  ULongAddTemp ( ULongPub * mep , ULongPub * lp )  ;
# define  ULongAddConst Lisp2DULongAddConst
void  ULongAddConst ( ULongPub * mep, ULongPub  const * lp) ;
# define  ULongLess Lisp2DULongLess
bool  ULongLess ( ULongPub  const * myp , ULongPub const * xp)  ;
# define  ULongMoreOrEqSizet  Lisp2DULongMoreOrEqSizet
bool  ULongMoreOrEqSizet ( ULongPub const * myp ,size_t x);
# define ULongDividingAndReturnsRemainder \
Lisp2DULongDividingAndReturnsRemainder
unsigned  int ULongDividingAndReturnsRemainder ( ULongPub * mep ,
  unsigned  int divisor ) ;
# define  ULongMultiplyConst  Lisp2DULongMultiplyConst
void  ULongMultiplyConst ( ULongPub * me, ULongPub  const * lp )  ;
# define  ULongMultiplyMove Lisp2DULongMultiplyMove
void  ULongMultiplyMove ( ULongPub * mep , ULongPub  *  lp ) ;
# define  ULongMultiplyUInt Lisp2DULongMultiplyUInt
void  ULongMultiplyUInt ( ULongPub * myp , unsigned int ui ) ;
# define  ULongFactorial  Lisp2DULongFactorial
void  ULongFactorial ( ULongPub * myp ) ;
// me=Floor[sqrt(myp)]
# define  ULongISqrt  Lisp2DULongISqrt
void  ULongISqrt ( ULongPub * myp ) ;
// returns  GCD, not disturb itself
# define  ULongGCD3 Lisp2DULongGCD3
unsigned  int ULongGCD3 ( ULongPub const * myp , unsigned  int x ) ;
# define  ULongIsx2x5 Lisp2DULongIsx2x5
bool  ULongIsx2x5 ( ULongPub const * myp ) ;

// this=this^n
// used by ULongPowerSize when my was very big
# define  ULongPowerSizet Lisp2DULongPowerSizet
void  ULongPowerSizet ( ULongPub * my ,size_t   n) ;

// ! to use PowerSize ?
# define  ULongSquare Lisp2DULongSquare
void  ULongSquare ( ULongPub * mep  ) ;

// this=this^n
# define  ULongPowerSize Lisp2DULongPowerSize
void  ULongPowerSize ( ULongPub * my ,size_t   n) ;
# define  ULongDivConst Lisp2DULongDivConst
void ULongDivConst ( ULongPub * myp ,  ULongPub const * by ) ;
# define  ULongDivWithOstSet  Lisp2DULongDivWithOstSet
void ULongDivWithOstSet ( ULongPub * myp , ULongPub const * lp , ULongPub * ostp ) ;
// ! (*lp)<>0 !
# define  ULongDivMove  Lisp2DULongDivMove
void ULongDivMove ( ULongPub * myp , ULongPub * lp );  
// binary Evclide
// ! to add GCDMove ( ... , ULongPub * xp  
# define  ULongGCD  Lisp2DULongGCD
void ULongGCD ( ULongPub * myp, ULongPub const * xp );

# include "widestring.h"

// WideChar or Char
# define LISP2DPROMOULONGADDTOWITHOUTEXP( STRNAME ) \
void  Lisp2DULongAddToStr ##  STRNAME ##  WithoutExp ( ULongPub const * , String  ( STRNAME ) * ) ;
  
LISP2DPROMOULONGADDTOWITHOUTEXP ( WideChar  )

LISP2DPROMOULONGADDTOWITHOUTEXP ( Char  )

// WideChar or Char
# define LISP2DDECLAREULONGADDTO( STRNAME ) \
void  Lisp2DULongAddToStr ##  STRNAME ( ULongPub const * , String  ( STRNAME ) * ) ;

LISP2DDECLAREULONGADDTO ( WideChar  )

LISP2DDECLAREULONGADDTO ( Char  )  

# define  StackNew_ULong  Lisp2D_StackNew_ULong
ULongPub * StackNew_ULong ( void  ) ;

# define  voidpcastulongpub Lisp2D_voidpcastulongpub
inline  ULongPub * voidpcastulongpub ( void * ) ;

# define  ULongClear  Lisp2DULongClear
inline  void  ULongClear ( ULongPub * ) ;

# define  ULongSet0 Lisp2DULongSet0
inline  void  ULongSet0  ( ULongPub * ) ;

# define  ULongValueSize  Lisp2DULongValueSize
inline  size_t  ULongValueSize ( ULongPub const * ) ;

# define  ULongIs0  Lisp2DULongIs0
inline  bool  ULongIs0 ( ULongPub const * ) ;

# include "stack-unsint.h"

# define  ULongCValue Lisp2DULongCValue
inline Vector ( StackUnsInt ) const * ULongCValue ( ULongPub const * ) ;

# define  ULongToPub Lisp2D_ULongToPub
inline  ULongPub * ULongToPub ( ULong * ) ;

# define  ULongSub1 Lisp2DULongSub1
void  ULongSub1 ( ULongPub * ) ;

# define  ULongCToPub Lisp2D_ULongCToPub
inline  ULongPub const  * ULongCToPub ( ULong const  * ) ;

# define  ULongLessOrEq Lisp2DULongLessOrEq
bool  ULongLessOrEq  ( ULongPub  const * my , ULongPub  const * x ) ;

# define  ULongMore Lisp2DULongMore
inline  bool  ULongMore ( ULongPub  const * my , ULongPub  const * x ) ;

# define  ULongMoreOrEq Lisp2DULongMoreOrEq
bool  ULongMoreOrEq  ( ULongPub  const * my , ULongPub  const * x ) ;

# define  ULongSet  Lisp2DULongSet
inline  void  ULongSet ( ULongPub * my , ULongPub  const * x ) ;

# define  ULongMove Lisp2DULongMove
inline  void  ULongMove ( ULongPub * my , ULongPub * x ) ;

# define  ULongSwap Lisp2DULongSwap
inline  void  ULongSwap ( ULongPub * my , ULongPub * x ) ;

#   define  ULongOddP Lisp2DULongOddP
bool  ULongOddP  ( ULongPub const * ) ;

# define  ULongMul2 Lisp2DULongMul2
void  ULongMul2 ( ULongPub  * ) ;

# define  ULongSetPointer  Lisp2DULongSetPointer
void  ULongSetPointer ( ULongPub * my , void  * x ) ;

# include "widestring/inline.h"

# endif // LISP2D_ULONG_PUBLIC_H
