// Lisp2D - Wide Character String Inline
// ©2019-23 by Alex Glebe

# ifndef  LISP2D_WIDESTRING_INLINE_H
# define  LISP2D_WIDESTRING_INLINE_H
# include "widestring.h"
inline  LISP2DSTRINGINIT ( WideChar , L'\0' )
inline  LISP2DSTRINGCSTR ( WideChar , wchar_t volatile  )
inline  LISP2DSTRINGCBEGIN  ( WideChar , wchar_t volatile )
inline  LISP2DSTRINGEMPTY ( WideChar ) // "" = [ \00 ]
inline  LISP2DSTRINGSIZE  ( WideChar )
inline  LISP2DSTRINGELTCOPY ( WideChar , wchar_t )
inline  LISP2DSTRINGELTCADDR  ( WideChar , wchar_t volatile )
inline  LISP2DSTRINGELTADDR ( WideChar , wchar_t volatile )
inline  LISP2DSTRINGSET ( WideChar )
inline  LISP2DSTRINGBEGIN ( WideChar , wchar_t volatile )
# endif // LISP2D_WIDESTRING_INLINE_H
